unit STUIniFileConsts_U;
// Description: SecureTrayUtil INI File Sections and Keys
// By Sarah Dean
// Email: sdean12@softhome.net
// WWW:   http://www.SDean12.org/
//
// -----------------------------------------------------------------------------
//
// Defines INI file consts for sections and keys


interface

uses
     AppGlobalConsts_U,
     Forms;

const
  // -------------------------------------------
  SECTION_SECURETRAYUTIL     = 'SecureTrayUtil';
    KEY_VERSION                    = 'Version';
    KEY_MAJOR_VERSION              = 'MajorVersion';
    KEY_MINOR_VERSION              = 'MinorVersion';
    KEY_RELEASE_VERSION            = 'ReleaseVersion';
    KEY_BUILD_VERSION              = 'BuildVersion';
    KEY_BETA_VERSION               = 'BETAVersion';

    KEY_STARTUPSHOWVOLINFODLG         = 'StartUpVolInfoDlg';
      DFLT_KEY_STARTUPSHOWVOLINFODLG   = FALSE;
    KEY_USEDISPLAYTASKTRAYICON        = 'DisplayTaskTrayIcon';
      DFLT_KEY_USEDISPLAYTASKTRAYICON  = TRUE;
    KEY_CONFIRMONDISMOUNT             = 'ConfirmOnDismount';
      DFLT_KEY_CONFIRMONDISMOUNT       = TRUE;
    // Tasktray icon...
    KEY_TASKTRAY_ICON_UNMOUNTED             = 'TasktrayIconUnmounted';
      DFLT_KEY_TASKTRAY_ICON_UNMOUNTED      = 5;
    KEY_TASKTRAY_ICON_MOUNTED               = 'TasktrayIconMounted';
      DFLT_KEY_TASKTRAY_ICON_MOUNTED        = 6;
    KEY_TASKTRAY_ICON_UNSURE                = 'TasktrayIconUnsure';
      DFLT_KEY_TASKTRAY_ICON_UNSURE         = 7;
    KEY_USEALTERNATETASKTRAYMENU            = 'AlternateTaskTrayMenu';
      DFLT_KEY_USEALTERNATETASKTRAYMENU     = FALSE;
    // Hotkeys...
    KEY_VOLINFOHOTKEYENABLE          = 'HotkeyVolInfoEnable';
      DFLT_KEY_VOLINFOHOTKEYENABLE     = FALSE;
    KEY_VOLINFOHOTKEY                = 'HotkeyVolInfoKey';
      DFLT_KEY_VOLINFOHOTKEY           = 'Shift+Ctrl+I';
    KEY_SCREENSAVERHOTKEYENABLE       = 'HotkeyScreenSaverEnable';
      DFLT_KEY_SCREENSAVERHOTKEYENABLE = FALSE;
    KEY_SCREENSAVERHOTKEY             = 'HotkeyScreenSaverKey';
      DFLT_KEY_SCREENSAVERHOTKEY       = 'Shift+Ctrl+S';
    KEY_EXITHOTKEYENABLE           = 'HotkeyExitEnable';
      DFLT_KEY_EXITHOTKEYENABLE      = FALSE;
    KEY_EXITHOTKEY                 = 'HotkeyExitKey';
      DFLT_KEY_EXITHOTKEY            = 'Shift+Ctrl+E';
    // Shredder...
    KEY_SHREDFILEDIRUSEINT         = 'ShredFileDirUseInt';
      DFLT_KEY_SHREDFILEDIRUSEINT    = TRUE;
    KEY_SHREDFREEUSEINT            = 'ShredFreeUseInt';
      DFLT_KEY_SHREDFREEUSEINT       = TRUE;
    KEY_SHREDSLACK                 = 'ShredSlack';
      DFLT_KEY_SHREDSLACK            = FALSE;
    KEY_SHREDEXTFILEEXE            = 'ExtShredFileExe';
      DFLT_KEY_SHREDEXTFILEEXE       = '';
    KEY_SHREDEXTDIREXE             = 'ExtShredDirExe';
      DFLT_KEY_SHREDEXTDIREXE        = '';
    KEY_SHREDEXTFREESPACEEXE       = 'ExtShredFreeSpaceExe';
      DFLT_KEY_SHREDEXTFREESPACEEXE  = '';
    KEY_SHREDEXTDIRDIFF            = 'ExtShredDiffForDirs';
      DFLT_KEY_SHREDEXTDIRDIFF       = FALSE;
    KEY_SHREDEXTFILESTHENDIR       = 'ExtShredFilesThenDir';
      DFLT_KEY_SHREDEXTFILESTHENDIR  = FALSE;
    KEY_SHREDINTFIRSTBYTES         = 'ShredFirstBytes';
      DFLT_KEY_SHREDINTFIRSTBYTES    = 1048576;
    KEY_SHREDINTPASSES             = 'ShredPasses';
      DFLT_KEY_SHREDINTPASSES        = 1;
    KEY_SHREDINTUSEGUTMANN         = 'UseGutmann';
      DFLT_KEY_SHREDINTUSEGUTMANN    = FALSE;
    KEY_SHREDINTSHOWPROGRESS       = 'ShowProgress';
      DFLT_KEY_SHREDINTSHOWPROGRESS  = TRUE;

    KEY_SHREDINTFREESPCFILESZ         = 'FreeSpaceFileSize';
      DFLT_KEY_SHREDINTFREESPCFILESZ   = 4194304;
    KEY_SHREDINTFREESPCFILECREATIONBLKSZ        = 'FreeSpaceFileCreationBlockSize';
      DFLT_KEY_SHREDINTFREESPCFILECREATIONBLKSZ  = 524288;
    KEY_SHREDINTFILEBUFSZ             = 'FileBufferSize';
      DFLT_KEY_SHREDINTFILEBUFSZ       = 65538;

  // -------------------------------------------
  SECTION_VOLINFO_DLG             = 'VolInfoDlg';
    // Volume info dialog...
    KEY_VOLINFO_DIALOG_ICONVIEW                = 'IconView';
        DFLT_KEY_VOLINFO_DIALOG_ICONVIEW         = FALSE;
    KEY_VOLINFO_DIALOG_TREEVIEW                = 'TreeView';
        DFLT_KEY_VOLINFO_DIALOG_TREEVIEW         = TRUE;
    KEY_VOLINFO_DIALOG_TABLEVIEW               = 'TableView';
        DFLT_KEY_VOLINFO_DIALOG_TABLEVIEW        = FALSE;
    KEY_VOLINFO_DIALOG_DISPVOLINFOPANEL        = 'DispVolInfoPanel';
        DFLT_KEY_VOLINFO_DIALOG_DISPVOLINFOPANEL = TRUE;
    KEY_VOLINFO_DIALOG_DISPNONENCRYPTED        = 'DispNonEncrypted';
        DFLT_KEY_VOLINFO_DIALOG_DISPNONENCRYPTED = TRUE;
    KEY_VOLINFO_DIALOG_HEIGHT               = 'Height';
        DFLT_KEY_VOLINFO_DIALOG_HEIGHT        = -1;
    KEY_VOLINFO_DIALOG_WIDTH                = 'Width';
        DFLT_KEY_VOLINFO_DIALOG_WIDTH         = -1;
    KEY_VOLINFO_DIALOG_TOP                  = 'Top';
        DFLT_KEY_VOLINFO_DIALOG_TOP           = -1;
    KEY_VOLINFO_DIALOG_LEFT                 = 'Left';
        DFLT_KEY_VOLINFO_DIALOG_LEFT          = -1;
    KEY_VOLINFO_DIALOG_WINDOWSTATE          = 'WindowState';
        DFLT_KEY_VOLINFO_DIALOG_WINDOWSTATE   = -1;
    KEY_VOLINFO_DIALOG_COLPOSDRIVE                  = 'ColPos_Drive';
        DFLT_KEY_VOLINFO_DIALOG_COLPOSDRIVE           = 0;
    KEY_VOLINFO_DIALOG_COLPOSVOLLABEL               = 'ColPos_VolLabel';
        DFLT_KEY_VOLINFO_DIALOG_COLPOSVOLLABEL        = 1;
    KEY_VOLINFO_DIALOG_COLPOSVOLFILENAME            = 'ColPos_VolFilename';
        DFLT_KEY_VOLINFO_DIALOG_COLPOSVOLFILENAME     = 2;
    KEY_VOLINFO_DIALOG_COLWIDTHDRIVE                = 'ColWidth_Drive';
        DFLT_KEY_VOLINFO_DIALOG_COLWIDTHDRIVE         = -1;
    KEY_VOLINFO_DIALOG_COLWIDTHVOLLABEL             = 'ColWidth_VolLabel';
        DFLT_KEY_VOLINFO_DIALOG_COLWIDTHVOLLABEL      = -1;
    KEY_VOLINFO_DIALOG_COLWIDTHVOLFILENAME          = 'ColWidth_VolFilename';
        DFLT_KEY_VOLINFO_DIALOG_COLWIDTHVOLFILENAME   = -1;

  // -------------------------------------------
  SECTION_OTFCRYPTOSYSTEMS        = 'OTFCryptoSystems';
    // Supported OTF systems
    KEY_OTFCS_SUPPORT             = 'OTFSystem_';
      DFLT_KEY_OTFCS_SUPPORT        = TRUE;

    // Default OTF system
    KEY_OTFCS_DEFAULTSYSTEM               = 'DefaultOTFSystem';
      // !!! WARNING !!!
      // This next one *MUST* equal to OTFESInternalNames[otfesScramDisk]
      // as defined in OTFEUnified_U
      DFLT_KEY_OTFCS_DEFAULTSYSTEM          = 'SCRAMDISK'; // !!! WARNING !!!
    KEY_OTFCS_DEFAULT_PROMPT_DIR          = 'DefaultPromptDir';
      DFLT_KEY_OTFCS_DEFAULT_PROMPT_DIR     = '';
    KEY_OTFCS_DEFAULT_PROMPT_FILTER       = 'DefaultPromptFilter';
      DFLT_KEY_OTFCS_DEFAULT_PROMPT_FILTER  = 1;
    KEY_OTFCS_EXPLOREAFTERMOUNT           = 'ExploreAfterMount';
      DFLT_KEY_OTFCS_EXPLOREAFTERMOUNT      = FALSE;
    KEY_OTFCS_MOUNTVOLSTART               = 'MountVolStart';
      DFLT_KEY_OTFCS_MOUNTVOLSTART          = FALSE;
    KEY_OTFCS_MOUNTPARTSTART              = 'MountPartStart';
      DFLT_KEY_OTFCS_MOUNTPARTSTART         = FALSE;
    KEY_OTFCS_ALWAYSUNMOUNTEDICON         = 'UnmountedIcon';
      DFLT_KEY_OTFCS_ALWAYSUNMOUNTEDICON    = FALSE;
    KEY_OTFCS_HIDEPASSWORDSENTEREDCK      = 'HidePasswordsEnteredCk';
      DFLT_KEY_OTFCS_HIDEPASSWORDSENTEREDCK = TRUE;

    KEY_OTFCS_PREPOSTEXE_POSTMOUNT         = 'PrePostExe_PostMount';
      DFLT_KEY_OTFCS_PREPOSTEXE_POSTMOUNT    = '';
    KEY_OTFCS_PREPOSTEXE_PREDISMOUNT       = 'PrePostExe_PreDismount';
      DFLT_KEY_OTFCS_PREPOSTEXE_PREDISMOUNT  = '';
    KEY_OTFCS_PREPOSTEXE_POSTDISMOUNT      = 'PrePostExe_PostDismount';
      DFLT_KEY_OTFCS_PREPOSTEXE_POSTDISMOUNT = '';
    KEY_OTFCS_PREPOSTEXE_WARNNOTFOUND      = 'PrePostExe_WarnNotFound';
      DFLT_KEY_OTFCS_PREPOSTEXE_WARNNOTFOUND = TRUE;


    KEY_OTFCS_ONEXIT                     = 'OnExit';
      DFLT_KEY_OTFCS_ONEXIT                = 0;
    KEY_OTFCS_ONDBLCLK                   = 'OnDblClk';
      DFLT_KEY_OTFCS_ONDBLCLK              = 0;
    KEY_OTFCS_DISMOUNTENABLE             = 'HotkeyDismountEnable';
      DFLT_KEY_OTFCS_DISMOUNTENABLE        = FALSE;
    KEY_OTFCS_DISMOUNTBRUTALENABLE       = 'HotkeyDismountBrutalEnable';
      DFLT_KEY_OTFCS_DISMOUNTBRUTALENABLE  = FALSE;
    KEY_OTFCS_DISMOUNTHOTKEY             = 'HotkeyDismountKey';
      DFLT_KEY_OTFCS_DISMOUNTHOTKEY        = 'Shift+Ctrl+D';
    KEY_OTFCS_DISMOUNTBRUTALHOTKEY       = 'HotkeyDismountBrutalKey';
      DFLT_KEY_OTFCS_DISMOUNTBRUTALHOTKEY  = 'Shift+Ctrl+Alt+D';

  // -------------------------------------------
  SECTION_TOUCHFILES        = 'TouchFiles';
    // Touch files
    KEY_TOUCHFILESCOUNT               = 'FilesCount';
      DFLT_KEY_TOUCHFILESCOUNT          = 0;
    KEY_TOUCHFILESTGT                 = 'TargetFile_';
      DFLT_KEY_TOUCHFILESTGT            = '';
    KEY_TOUCHFILESTGTDATETIME         = 'TargetFileDateTime_';
      DFLT_KEY_TOUCHFILESTGTDATETIME    = '1/1/1980';
    KEY_TOUCHFILESTGTUSECURRENTDATEDATETIME   = 'TargetFileCurrentDateTime_';
      DFLT_KEY_TOUCHFILESTGTCURRENTDATEDATETIME = TRUE;
    KEY_TOUCHFILESFREQUENCY           = 'Frequency';
      DFLT_KEY_TOUCHFILESFREQUENCY      = 3600; // 1 hour
    KEY_TOUCHFILESREGULARLY           = 'Regularly';
      DFLT_KEY_TOUCHFILESREGULARLY      = FALSE;
    KEY_TOUCHFILESONSTART             = 'OnStart';
      DFLT_KEY_TOUCHFILESONSTART        = FALSE;
    KEY_TOUCHFILESONEXIT              = 'OnExit';
      DFLT_KEY_TOUCHFILESONEXIT         = FALSE;

  // -------------------------------------------
  SECTION_SHELLEXT          = 'ShellExt';
    KEY_SUBMENU                     = 'SubMenu';
      DFLT_KEY_SUBMENU                = FALSE;
    KEY_SUBMENUTITLE                = 'SubMenuTitle';
      DFLT_KEY_SUBMENUTITLE           = 'SecureTrayUtil';
    KEY_MENUITEM_SEPARATORS         = 'MenuSeparators';
      DFLT_KEY_MENUITEM_SEPARATORS    = TRUE;
    KEY_MENUITEM_MOUNTVOLUME        = 'MenuMountVolume';
      DFLT_KEY_MENUITEM_MOUNTVOLUME   = FALSE;
    KEY_MENUITEM_SHREDDIR           = 'MenuShredDir';
      DFLT_KEY_MENUITEM_SHREDDIR      = FALSE;
    KEY_MENUITEM_SHREDFILE          = 'MenuShredFile';
      DFLT_KEY_MENUITEM_SHREDFILE     = FALSE;
    KEY_MENUITEM_SHREDFREESPACE     = 'MenuShredFreeSpace';
      DFLT_KEY_MENUITEM_SHREDFREESPACE= FALSE;
    KEY_MENUITEM_TOUCH              = 'MenuTouch';
      DFLT_KEY_MENUITEM_TOUCH         = FALSE;
    KEY_MENUITEM_HASH               = 'MenuHash';
      DFLT_KEY_MENUITEM_HASH          = FALSE;
    KEY_APPPATH                     = 'AppPath';
      DFLT_KEY_APPPATH                = FALSE;

  // -------------------------------------------
  SECTION_HASH             = 'Hash';
    KEY_HASH_ENABLEHASH             = 'HASH_';
      DFLT_KEY_HASH_ENABLEHASH        = TRUE;
    KEY_HASH_UPPERCASE              = 'Uppercase';
      DFLT_KEY_HASH_UPPERCASE         = TRUE;

  // -------------------------------------------
  SECTION_SCRAMDISK         = 'ScramDisk';
    KEY_SCRAMDISKEXE                = 'ScramDiskExe';
      DFLT_KEY_SCRAMDISKEXE           = '';
    KEY_USEREDSCREEN                = 'UseRedScreen';
      DFLT_KEY_USEREDSCREEN           = FALSE;
    KEY_DISABLESVLPROTECTION        = 'DisableSVLProtection';
      DFLT_KEY_DISABLESVLPROTECTION   = FALSE;
    KEY_SCRAMDISKPREFDRIVE          = 'PreferredDrive';
      DFLT_KEY_SCRAMDISKPREFDRIVE     = 'S';

  // -------------------------------------------
  SECTION_OTFCROSSCRYPT                = 'CrossCrypt';
    KEY_CROSSCRYPTEXE                     = 'CrossCryptExe';
      DFLT_KEY_CROSSCRYPTEXE                = '';

  // -------------------------------------------
  SECTION_OTFE4M                = 'E4M';
    KEY_E4MEXE                     = 'E4MExe';
      DFLT_KEY_E4MEXE                = '';
    KEY_SUPPORTSCRAMDISK           = 'SupportScramDisk';
      DFLT_KEY_SUPPORTSCRAMDISK      = TRUE;
    KEY_E4MMOUNTDEVICEDLG9XSTYLE      = 'MountDeviceDlg9xStyle';
      DFLT_KEY_E4MMOUNTDEVICEDLG9XSTYLE = FALSE;

  // -------------------------------------------
  SECTION_OTFFREEOTFE                = 'FreeOTFE';
    KEY_FREEOTFEEXE                     = 'FreeOTFEEXE';
      DFLT_KEY_FREEOTFEEXE                = '';

  // -------------------------------------------
  SECTION_OTFTRUECRYPT                 = 'TrueCrypt';
    KEY_VERSIONHINT                       = 'VersionHint';
      DFLT_KEY_VERSIONHINT                  = 1; // "1" means no version hint
    KEY_TRUECRYPTMOUNTDEVICEDLG9XSTYLE      = 'MountDeviceDlg9xStyle';
      DFLT_KEY_TRUECRYPTMOUNTDEVICEDLG9XSTYLE = FALSE;

  // -------------------------------------------
  SECTION_SELFD            = 'SelfDestruct';
    KEY_FACILITIESENABLE1               = 'FacilitiesEnable1';
      DFLT_KEY_FACILITIESENABLE1          = FALSE;
    KEY_FACILITIESENABLE2               = 'FacilitiesEnable2';
      DFLT_KEY_FACILITIESENABLE2          = FALSE;
    KEY_ENABLEMENUTRIGGER               = 'EnableMenuTrigger';
      DFLT_KEY_ENABLEMENUTRIGGER          = FALSE;
    KEY_MENUTRIGGERLOCATION             = 'MenuTriggerLocation';
      DFLT_KEY_MENUTRIGGERLOCATION        = 0;
    KEY_ENABLESELFDHOTKEY               = 'EnableHotkey';
      DFLT_KEY_ENABLESELFDHOTKEY          = FALSE;
    KEY_SELFDHOTKEY                     = 'Hotkey';
      DFLT_KEY_SELFDHOTKEY                = '(None)';
    KEY_ENABLESERIALTRIGGER             = 'EnableSerialTrigger';
      DFLT_KEY_ENABLESERIALTRIGGER        = FALSE;
    KEY_SERIALTRIGGERPORT               = 'SerialTriggerPort';
      DFLT_KEY_SERIALTRIGGERPORT          = '';
    KEY_SERIALTRIGGERINTERVAL           = 'SerialTriggerInterval';
      DFLT_KEY_SERIALTRIGGERINTERVAL      = 1000;
    KEY_ENABLEINTERNETTRIGGER           = 'EnableInternetTrigger';
      DFLT_KEY_ENABLEINTERNETTRIGGER      = FALSE;
    KEY_INTERNETTRIGGERPORT             = 'InternetTriggerPort';
      DFLT_KEY_INTERNETTRIGGERPORT        = 23;
    KEY_INTERNETTRIGGERCRPAIRS          = 'InternetTriggerCRPairs';
      DFLT_KEY_INTERNETTRIGGERCRPAIRS      = 1;
    KEY_INTERNETTRIGGERCHAL             = 'InternetTriggerChallenge';
      DFLT_KEY_INTERNETTRIGGERCHAL        = 'Challenge';
    KEY_INTERNETTRIGGERRESP             = 'InternetTriggerResponse';
      DFLT_KEY_INTERNETTRIGGERRESP        = 'Response';
    KEY_TRIGGERTESTMODE                 = 'TriggerTestMode';
      DFLT_KEY_TRIGGERTESTMODE            = FALSE;
    KEY_DESTROYMOUNTEDENABLE            = 'DestroyMounted';
      DFLT_KEY_DESTROYMOUNTEDENABLE       = FALSE;
    KEY_DESTROYMOUNTEDQUICK              = 'DestroyMountedQuick';
      DFLT_KEY_DESTROYMOUNTEDQUICK        = FALSE;
    KEY_RUNADDITIONALENABLE             = 'RunAdditionalEnable';
      DFLT_KEY_RUNADDITIONALENABLE        = FALSE;
    KEY_RUNADDITIONALFILENAME           = 'RunAdditionalFilename';
      DFLT_KEY_RUNADDITIONALFILENAME      = '';
    KEY_STEALTHSELFD                    = 'StealthSelfDestruct';
      DFLT_KEY_STEALTHSELFD               = FALSE;
    KEY_RANDOMIZECLOCK                  = 'RandomizeClock';
      DFLT_KEY_RANDOMIZECLOCK             = FALSE;
    KEY_RANDOMIZECLOCKSTARTDATETIME     = 'RandomizeClockStartDateTime';
    KEY_RANDOMIZECLOCKENDDATETIME       = 'RandomizeClockEndDateTime';
    KEY_RANDOMIZECLOCKSTARTCURRENT      = 'RandomizeClockStartCurrent';
      DFLT_KEY_RANDOMIZECLOCKSTARTCURRENT = FALSE;
    KEY_RANDOMIZECLOCKENDCURRENT        = 'RandomizeClockEndCurrent';
      DFLT_KEY_RANDOMIZECLOCKENDCURRENT   = FALSE;

  // -------------------------------------------
  SECTION_SELFDTARGETS      = 'Targets';
    KEY_TARGETSCOUNT               = 'Count';
      DFLT_KEY_TARGETSCOUNT          = 0;
    KEY_TARGET                     = 'File';
      DFLT_KEY_TARGET                = '';

  // -------------------------------------------

implementation

END.

