unit About_U;
// Description: About Dialog
// By Sarah Dean
// Email: sdean12@softhome.net
// WWW:   http://www.SDean12.org/
//
// -----------------------------------------------------------------------------
//


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls,
  OTFEUnified_U, SDUURLLabel;

type
  TAbout_F = class(TForm)
    pbOK: TButton;
    Image1: TImage;
    lblAppID: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    GroupBox1: TGroupBox;
    pnlVersions: TPanel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    pnlEnableSystem: TPanel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Shape1: TShape;
    lblBeta: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    SDUURLLabel1: TSDUURLLabel;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Label11: TLabel;
    Label12: TLabel;
    procedure FormShow(Sender: TObject);
  private
    procedure CheckOTFComponents();
  public
    OTFEUnified: TOTFEUnified;
  end;

implementation

{$R *.DFM}

uses AppGlobalConsts_U, SDUGeneral,
     AppGlobal_U,
     STUIniFile_U;

procedure TAbout_F.FormShow(Sender: TObject);
var
  majorVersion   : integer;
  minorVersion   : integer;
  revisionVersion: integer;
  buildVersion   : integer;
begin
  SDUGetVersionInfo('', majorVersion, minorVersion, revisionVersion, buildVersion);
  lblAppID.caption := 'v'+SDUGetVersionInfoString('');
  if APP_BETA_BUILD>-1 then
    begin
    lblAppID.caption := lblAppID.caption + ' BETA '+inttostr(APP_BETA_BUILD);
    end;

  lblBeta.visible := (APP_BETA_BUILD>-1);

  pnlEnableSystem.bevelouter := bvNone;
  pnlVersions.bevelouter := bvNone;

  CheckOTFComponents();

end;

procedure TAbout_F.CheckOTFComponents();
const
  STR_NOT_DETECTED = 'not detected';
var
  currSystemInstalled: boolean;
  OTFSystemLoop: TOTFESystem;
  loopOrd: integer;
  enableLabel: boolean;
  strOTFEVersion: string;
begin
  for OTFSystemLoop:=low(OTFEUnified.OTFComponents) to high(OTFEUnified.OTFComponents) do
    begin
    loopOrd:= ord(OTFSystemLoop);
    TLabel(SDUGetControlWithTag(loopOrd, pnlEnableSystem)).caption := OTFESDispNames[OTFSystemLoop];
    currSystemInstalled := OTFEUnified.OTFComponents[OTFSystemLoop].IsDriverInstalled();

    if currSystemInstalled then
      begin
      if not(STU_INI_FILE.OptOTFCryptoSupport[OTFSystemLoop]) then
        begin
        OTFEUnified.OTFComponents[OTFSystemLoop].Active := TRUE;
        end;

      strOTFEVersion := OTFEUnified.OTFComponents[OTFSystemLoop].VersionStr();
      if strOTFEVersion='' then
        begin
        strOTFEVersion := '(Unknown)';
        end;
      TLabel(SDUGetControlWithTag(loopOrd, pnlVersions)).caption := strOTFEVersion;

      OTFEUnified.OTFComponents[OTFSystemLoop].Active := STU_INI_FILE.OptOTFCryptoSupport[OTFSystemLoop];
      end
    else
      begin
      TLabel(SDUGetControlWithTag(loopOrd, pnlVersions)).caption := STR_NOT_DETECTED;
      end;

    enableLabel := OTFEUnified.OTFEnabledComponents[OTFSystemLoop];
    TLabel(SDUGetControlWithTag(loopOrd, pnlEnableSystem)).enabled := enableLabel;
    TLabel(SDUGetControlWithTag(loopOrd, pnlVersions)).enabled := enableLabel;
    end;

end;

END.

