unit DriveSelect_U;
// Description: Drive select dialog for free disk space shredding
// By Sarah Dean
// Email: sdean12@softhome.net
// WWW:   http://www.SDean12.org/
//
// -----------------------------------------------------------------------------
//


interface

{$IFDEF LINUX}
This software is only intended for use under MS Windows
{$ENDIF}
{$WARN UNIT_PLATFORM OFF}  // Useless warning about platform - we're already
                           // protecting against that!

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FileCtrl;

type
  TDriveSelect_F = class(TForm)
    Label1: TLabel;
    dcvShredFreeDrive: TDriveComboBox;
    pbOK: TButton;
    pbCancel: TButton;
    gbInternalShredder: TGroupBox;
    pbConfigIntShredder: TButton;
    Label2: TLabel;
    procedure FormShow(Sender: TObject);
    procedure pbConfigIntShredderClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DriveSelect_F: TDriveSelect_F;

implementation

{$R *.DFM}

uses AppGlobal_U,
     ConfigShredderInt_U,
     SDUGeneral;

procedure TDriveSelect_F.FormShow(Sender: TObject);
begin
  SDUEnableControl(gbInternalShredder, STU_INI_FILE.OptShredFreeUseInt);

end;

procedure TDriveSelect_F.pbConfigIntShredderClick(Sender: TObject);
var
  configDlg: TConfigShredderInt_F;
begin
  configDlg := TConfigShredderInt_F.create(nil);
  try
    configDlg.showmodal();
  finally
    configDlg.Free();
  end;

end;


// -----------------------------------------------------------------------------

// -----------------------------------------------------------------------------
// -----------------------------------------------------------------------------
{$WARN UNIT_PLATFORM ON}
// -----------------------------------------------------------------------------

END.

