unit Main_U;
// Description: Main Unit, Dialog
// By Sarah Dean
// Email: sdean12@softhome.net
// WWW:   http://www.SDean12.org/
//
// -----------------------------------------------------------------------------
//


interface

{$IFDEF LINUX}
This software is only intended for use under MS Windows
{$ENDIF}
{$WARN UNIT_PLATFORM OFF}  // Useless warning about platform - we're already
                           // protecting against that!
{$WARN SYMBOL_PLATFORM OFF}  // Useless warning about platform - we're already
                             // protecting against that!

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus,
  ShellAPI, // Used to put an icon on the task tray
  Math, // Needed for the "max" function
  AppGlobal_U,
  STUINIFile_U, FileCtrl, StdCtrls,
  Registry, RegStr, ExtCtrls,
  COMPort_U,
  SDUProgress_U, ScktComp,
  SDUFileIterator_U,
  OTFE_U, OTFEUnified_U,
  HashAlgUnified_U,
  Shredder, XPMan;

const
  NIM_ADD    = $00000000;
  NIM_MODIFY = $00000001;
  NIM_DELETE = $00000002;

  HKEY_IDENT_DISMOUNT        = 1;
  HKEY_IDENT_DISMOUNT_BRUTAL = 2;
  HKEY_IDENT_SELF_DESTRUCT   = 3;
  HKEY_IDENT_SCREEN_SAVER    = 4;
  HKEY_IDENT_EXIT            = 5;
  HKEY_IDENT_VOLINFO         = 6;
  

type
  TShredDetails = array [0..2] of byte;
  TShredBlock = array of byte;
  TShredFreeSpaceBlock = array of byte;

  TsocketInfo = record
    chalNum: integer;
    currLine: string;
  end;
  pTsocketInfo = ^TsocketInfo;

  TShredFreeSpaceBlockObj = class
  public
    BLANK_FREESPACE_BLOCK: TShredFreeSpaceBlock;
  end;

  TMain_F = class(TForm)
    muPopupMenu1: TPopupMenu;
    miMountVolume: TMenuItem;
    miDismountAllNormal: TMenuItem;
    miDismountAllEmergency: TMenuItem;
    miExit: TMenuItem;
    miAbout: TMenuItem;
    miLineMount: TMenuItem;
    miLineDismount2: TMenuItem;
    miOptionsOTFSystems: TMenuItem;
    miLineOptions: TMenuItem;
    miInformation: TMenuItem;
    miSelfDestructLine1: TMenuItem;
    miSelfDestruct1: TMenuItem;
    miSelfDestructLine2: TMenuItem;
    miSelfDestruct2: TMenuItem;
    miOptions: TMenuItem;
    miOptionsSelfDestruct: TMenuItem;
    miMountPartition: TMenuItem;
    miShredFile: TMenuItem;
    miShredDir: TMenuItem;
    miOptionsGeneral: TMenuItem;
    miShred: TMenuItem;
    ttSerialSelfDTrigger: TTimer;
    ttTriggerTestModeWarning: TTimer;
    miShredFreeSpace: TMenuItem;
    miLineDismount1: TMenuItem;
    miDismount: TMenuItem;
    ttTouchFiles: TTimer;
    ttCloseTimer: TTimer;
    muCommonMenu: TMainMenu;
    miCommonLaunch: TMenuItem;
    miCommonLaunchScramDisk: TMenuItem;
    miCommonLaunchPGPDisk: TMenuItem;
    miCommonLaunchE4M: TMenuItem;
    miCommonLaunchBestCrypt: TMenuItem;
    miLaunch: TMenuItem;
    miLaunchScramDisk: TMenuItem;
    miLaunchPGPDisk: TMenuItem;
    miLaunchE4M: TMenuItem;
    miLaunchBestCrypt: TMenuItem;
    miCommonShred: TMenuItem;
    miCommonShredFreeSpace: TMenuItem;
    miCommonShredDir: TMenuItem;
    miCommonShredFile: TMenuItem;
    miCommonOptions: TMenuItem;
    miCommonOptionsSelfDestruct: TMenuItem;
    miCommonOptionsOTFSystems: TMenuItem;
    miCommonOptionsGeneral: TMenuItem;
    miCommonHelp: TMenuItem;
    miCommonAboutSecureTrayUtil: TMenuItem;
    ShredFileDialog: TOpenDialog;
    miTouch: TMenuItem;
    miCommonOther: TMenuItem;
    miCommonTouch: TMenuItem;
    miCommonHash: TMenuItem;
    miHash: TMenuItem;
    miOther: TMenuItem;
    muPopupMenu2: TPopupMenu;
    miAltSelfDestruct1: TMenuItem;
    miAltSelfDestructLine1: TMenuItem;
    miAltMountVolume: TMenuItem;
    miAltMountPartition: TMenuItem;
    miAltLineMount: TMenuItem;
    miAltDismount: TMenuItem;
    miAltLineDismount1: TMenuItem;
    miAltDismountAllNormal: TMenuItem;
    miAltDismountAllEmergency: TMenuItem;
    miAltLineDismount2: TMenuItem;
    miAltInformation: TMenuItem;
    miAltLaunch: TMenuItem;
    miAltLaunchBestCrypt: TMenuItem;
    miAltLaunchE4M: TMenuItem;
    miAltLaunchPGPDisk: TMenuItem;
    miAltLaunchScramDisk: TMenuItem;
    miAltShred: TMenuItem;
    miAltShredFile: TMenuItem;
    miAltShredDir: TMenuItem;
    miAltShredFreeSpace: TMenuItem;
    miAltOther: TMenuItem;
    miAltTouch: TMenuItem;
    miAltHash: TMenuItem;
    miAltOptions: TMenuItem;
    miAltOptionsGeneral: TMenuItem;
    miAltOptionsOTFSystems: TMenuItem;
    miAltOptionsSelfDestruct: TMenuItem;
    miAltLineOptions: TMenuItem;
    miAltAbout: TMenuItem;
    miAltExit: TMenuItem;
    miAltSelfDestructLine2: TMenuItem;
    miAltSelfDestruct2: TMenuItem;
    miCommonLaunchTrueCrypt: TMenuItem;
    miAltLaunchTrueCrypt: TMenuItem;
    miLaunchTrueCrypt: TMenuItem;
    miLaunchCrossCrypt: TMenuItem;
    miLaunchFreeOTFE: TMenuItem;
    miAltLaunchFreeOTFE: TMenuItem;
    miAltLaunchCrossCrypt: TMenuItem;
    miCommonLaunchCrossCrypt: TMenuItem;
    miCommonLaunchFreeOTFE: TMenuItem;
    OTFEUnified: TOTFEUnified;
    XPManifest1: TXPManifest;
    procedure miAboutSecureTrayUtilClick(Sender: TObject);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure miExitClick(Sender: TObject);
    procedure miInformationClick(Sender: TObject);
    procedure miMountVolumeClick(Sender: TObject);
    procedure miOptionsOTFSystemsClick(Sender: TObject);
    procedure miDismountAllNormalClick(Sender: TObject);
    procedure miDismountAllEmergencyClick(Sender: TObject);
    procedure miSelfDestructClick(Sender: TObject);
    procedure miOptionsSelfDestructClick(Sender: TObject);
    procedure miMountPartitionClick(Sender: TObject);
    procedure miShredFileClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure miShredDirClick(Sender: TObject);
    procedure miOptionsGeneralClick(Sender: TObject);
    procedure ttSerialSelfDTriggerTimer(Sender: TObject);
    procedure ttTriggerTestModeWarningTimer(Sender: TObject);
    procedure miShredFreeSpaceClick(Sender: TObject);
    procedure miDismountClick(Sender: TObject);
    procedure ttTouchFilesTimer(Sender: TObject);
    procedure miLaunchScramDiskClick(Sender: TObject);
    procedure miLaunchE4MClick(Sender: TObject);
    procedure miLaunchBestCryptClick(Sender: TObject);
    procedure miLaunchPGPDiskClick(Sender: TObject);
    procedure ttCloseTimerTimer(Sender: TObject);
    procedure ShredFileDialogShow(Sender: TObject);
    procedure miTouchClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure miHashClick(Sender: TObject);
    procedure miLaunchTrueCryptClick(Sender: TObject);
    procedure miLaunchFreeOTFEClick(Sender: TObject);
    procedure miLaunchCrossCryptClick(Sender: TObject);
  private
    TrayIcon: TNotifyIconData;
    hIconMounted: hIcon;
    hIconUnmounted: hIcon;
    hIconUnsure : hIcon;
    COMPortObj: TCOMPort;
    VolInfoDlg: TForm;
    ServerSocket: TServerSocket;
    ShredderObj: TShredder;

    // This is needed to prevent modal dialogs being treated as non-modal
    // dialogs due to the user clickong on the tray icon and trying to display
    // another dialog. A bit clunky, but it works!
    // (Well, apart from then mounting volumes, and the ScramDisk component
    // displays it's own dialogs...)
    modalDialogDisplayed : TForm;
    procedure WMHotkey(var msg: TWMHotkey); message WM_HOTKEY;

    procedure WMQueryEndSession(var Msg : TWMQueryEndSession); message WM_QueryEndSession;
    procedure WMEndSession(var Msg : TWMEndSession); message WM_EndSession;

    // Internet socket stuff...
    procedure ServerSocketClientConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocketClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocketClientError(Sender: TObject;
      Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
      var ErrorCode: Integer);
    procedure ServerSocketClientRead(Sender: TObject;
      Socket: TCustomWinSocket);

    function  IsAModalDialogDisplayed() : boolean;
    procedure ModalDialogBeingDisplayed(theDialog : TForm);
    procedure ModalDialogNotBeingDisplayed();
    procedure SetupHotKeys();
    procedure EnableHotkey(hotkey : TShortCut; hotkeyIdent : integer);
    procedure DisableHotkey(hotkeyIdent : integer);
    procedure SelfDestruct();
    procedure EnableDisableMenuItems();
    procedure DestroyRegKey(key: string);
    procedure EnableOTFSystemFunctions(enable: boolean);
    procedure CheckCommandLineParameters();
    procedure LaunchScreenSaver();
    procedure EnableDisableSerialSelfDestruct();
    procedure EnableDisableInternetSelfDestruct();
    procedure EnableDisableTriggerTestMode();
    procedure SendChallengeToSocket(socket: TCustomWinSocket);
    function  TouchFile(filename: string; dateTimeStamp: TDateTime): boolean;
    function  TouchFileOrDir(fileOrDir: string; dateTimeStamp: TDateTime): boolean;
    procedure TouchTargetFiles();
    procedure EnableDisableLaunchMenuitems();
    procedure LoadTaskTrayIcons();
    procedure DestroyTaskTrayIcons();
    procedure DisplayVolInfoDlg();
    procedure AddOrRemoveTrayIcon();
    procedure RefreshDisplayAndTrayIcon();
    procedure CommandLineHashFile();
    procedure SyncPopupMenuItemStates();
    procedure SetupShredderObj();
    procedure GetRandomDate(var randomDate: SYSTEMTIME; startDT: TDateTime; endDT: TDateTime);
    procedure PrePostMountDismountExec(msgPart: string; exeFilename: string; waitForExit: boolean);
  public
    CommandLineOnly: boolean;
    StayLoaded: boolean;
    procedure InitApp();
    function  OTFCryptoMountPrompted(): string;
    function  OTFCryptoMountUnPrompted(volFiles: TStringList; readOnly: boolean): string;
    function  OTFCryptoMountPartition(): string;
    procedure OTFCryptoDismountPrompted();
    function  OTFCryptoDismountDrive(drive: char; emergency: boolean): boolean;
    function  OTFCryptoDismountAll(emergency: boolean; supressErrors: boolean = FALSE): boolean;
    function  ReportDismountFailure(failedDrvs: string): boolean;
    procedure UpdateTrayIcon();
    procedure ExitApp();
  end;


implementation

uses
  CommDlg, // needed to change the "Open" button on the ShredFileDialog to "Shred"
  About_U,
  AppGlobalConsts_U,
  OptionsGeneral_U,
  OptionsOTFSystems_U,
  OptionsSelfD_U,
  IniFiles, // needed to find out the screensaver filename
  WinInfo,
  VolumeInfo_U,
  DriveSelect_U,
  FileList_U,
  SDUGeneral,
  TouchFileSelect_U,
  DismountVolumes_U,
  OTFEConsts_U, // needed for return values
  OTFEE4M_U,
  OTFEScramDisk_U,
  OTFETrueCrypt_U,
  CalculateFileHash_U;

{$R *.DFM}
{$R IconOptions.dcr}

procedure TMain_F.miAboutSecureTrayUtilClick(Sender: TObject);
var
  frmAbout : TAbout_F;
begin
  if not(IsAModalDialogDisplayed()) then
    begin
    frmAbout := TAbout_F.create(nil);
    try
      ModalDialogBeingDisplayed(frmAbout);
      frmAbout.OTFEUnified := OTFEUnified;
      frmAbout.showmodal;
    finally
      ModalDialogNotBeingDisplayed();
      frmAbout.free;
    end;
    end; // not(IsAModalDialogDisplayed())
end;


procedure TMain_F.FormCreate(Sender: TObject);
var
  OTFSystemLoop: TOTFESystem;
begin
  ServerSocket:= nil;
  COMPortObj := TCOMPort.create();
  ShredderObj:= TShredder.Create(nil);

  CommandLineOnly := FALSE;
  StayLoaded := FALSE;
  ModalDialogNotBeingDisplayed();

  // Read in the ini file/setup it's defaults.
  STU_INI_FILE := TSTUIniFile.Create(INI_FILENAME);
  STU_INI_FILE.ReadIniFile();
  STU_INI_FILE.CheckVersionID();

  // Setup ScramDisk component options...
  TOTFEScramDisk(OTFEUnified.OTFComponents[otfesScramDisk]).useRedScreen := STU_INI_FILE.OptOTFScramDiskUseRedScreen;
  TOTFEScramDisk(OTFEUnified.OTFComponents[otfesScramDisk]).DefaultPromptDir := STU_INI_FILE.OptOTFDefaultBrowseDir;
  TOTFEScramDisk(OTFEUnified.OTFComponents[otfesScramDisk]).PreferredDrive := STU_INI_FILE.OptOTFScramDiskPrefDrive[1];
  TOTFEScramDisk(OTFEUnified.OTFComponents[otfesScramDisk]).HidePasswordsEnteredCk := STU_INI_FILE.OptOTFHidePasswordsEnteredCk;

  TOTFEE4M(OTFEUnified.OTFComponents[otfesE4M]).HidePasswordsEnteredCk := STU_INI_FILE.OptOTFHidePasswordsEnteredCk;
  TOTFEE4M(OTFEUnified.OTFComponents[otfesE4M]).MountDeviceDlg9xStyle := STU_INI_FILE.OptOTFE4MMountDeviceDlg9xStyle;

  TOTFETrueCrypt(OTFEUnified.OTFComponents[otfesTrueCrypt]).MountDeviceDlg9xStyle := STU_INI_FILE.OptOTFTrueCryptMountDeviceDlg9xStyle;

  for OTFSystemLoop:=low(OTFEUnified.OTFEnabledComponents) to high(OTFEUnified.OTFEnabledComponents) do
    begin
    OTFEUnified.OTFEnabledComponents[OTFSystemLoop] := STU_INI_FILE.OptOTFCryptoSupport[OTFSystemLoop];
    end;
  OTFEUnified.Active := TRUE;

  for OTFSystemLoop:=low(OTFEUnified.OTFEnabledComponents) to high(OTFEUnified.OTFEnabledComponents) do
    begin
    if (STU_INI_FILE.OptOTFCryptoSupport[OTFSystemLoop]) AND
       not(OTFEUnified.OTFComponents[OTFSystemLoop].Active) then
      begin
      STU_INI_FILE.OptOTFCryptoSupport[OTFSystemLoop] := FALSE;
      STU_INI_FILE.WriteIniFile();

      MessageDlg(
                 'Unable to initialize support for '+
                 OTFESDispNames[OTFSystemLoop]+
                 CRLF+
                 CRLF+
                 'If you do not have this OTFE system installed, you can safely '+
                 'ignore this message; SecureTrayUtil support for this system '+
                 'has been disabled so you should not see this message again. '+
                 CRLF+
                 CRLF+
                 'If you do have this system installed, and would like '+
                 'SecureTrayUtil to support it, please re-enable support '+
                 'via the OTFE Systems options dialog.',
                 mtWarning,
                 [mbOK],
                 0
                );

{
default system functionality disabled; it's never actually used

      if STU_INI_FILE.OptOTFCryptoDefault=OTFSystemLoop then
        begin
        MessageDlg(
                   'Since this is the default system, you should either install '+
                   'this system, or change your default OTFE system selection '+
                   '(see OTFE Systems options) ',
                   mtInformation,
                   [mbOK],
                   0
                  );
        end;
}
      end;
    end;

  // Setup ScramDisk post-active component options...
  if STU_INI_FILE.OptOTFCryptoSupport[otfesScramDisk] then
    begin
    TOTFEScramDisk(OTFEUnified.OTFComponents[otfesScramDisk]).SetEnableVolumeDeletion(STU_INI_FILE.OptOTFScramDiskDisableSVLProtection);
    end;

  // Setup E4M component options...
  if STU_INI_FILE.OptOTFCryptoSupport[otfesE4M] then
    begin
    if TOTFEE4M(OTFEUnified.OTFComponents[otfesE4M]).VersionCanSupportScramDiskVols() then
      begin
      TOTFEE4M(OTFEUnified.OTFComponents[otfesE4M]).SupportScramDisk := STU_INI_FILE.OptOTFE4MSupportScramDisk;
      end
    else
      begin
      TOTFEE4M(OTFEUnified.OTFComponents[otfesE4M]).SupportScramDisk := FALSE;
      end;
    end;

  SetupShredderObj();
  
  CheckCommandLineParameters();

  if CommandLineOnly then
    begin
    Close;
    Application.Terminate;
    end
  else
    begin
    VolInfoDlg:= TVolumeInfo_F.Create(nil);
    TVolumeInfo_F(VolInfoDlg).OTFEUnified := OTFEUnified;
    TVolumeInfo_F(VolInfoDlg).TheMainForm := self;
    TVolumeInfo_F(VolInfoDlg).InitDlg();

    if (STU_INI_FILE.OptOTFE4MExe='') AND
       (STU_INI_FILE.NewVersion)      AND
       (STU_INI_FILE.OptOTFCryptoSupport[otfesE4M]) then
      begin
      STU_INI_FILE.OptOTFE4MExe := OTFEUnified.OTFComponents[otfesE4M].GetMainExe();
      STU_INI_FILE.WriteIniFile();
      end;

    EnableDisableTriggerTestMode();
    EnableDisableSerialSelfDestruct();
    EnableDisableInternetSelfDestruct();
    ttTouchFiles.interval := STU_INI_FILE.OptTouchFrequency*1000;
    ttTouchFiles.enabled := STU_INI_FILE.OptTouchRegularly;
    if STU_INI_FILE.OptTouchOnStart then
      begin
      ttTouchFilesTimer(nil);
      end;

    if STU_INI_FILE.OptShowVolInfoOnStartup then
      begin
      DisplayVolInfoDlg();
      end;
    end;

end;

procedure TMain_F.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
  CursorPos: TPoint;
begin
  if x=WM_RBUTTONDOWN then
    begin
    // x = WM_RBUTTONDOWN if the right mousebutton has been pressed over the
    // icon - display the trayicon's context menu
    SetForegroundWindow(Handle);                     { Set the foreground window as your application }
    GetCursorPos(CursorPos);                         { Get the cursor position on screen }
    if STU_INI_FILE.OptTaskTrayAlternateMenu then
      begin
      SyncPopupMenuItemStates();
      muPopupMenu2.Popup(CursorPos.X, CursorPos.Y);     { Popup your TPopupMenu }
      end
    else
      begin
      muPopupMenu1.Popup(CursorPos.X, CursorPos.Y);     { Popup your TPopupMenu }
      end;
    PostMessage(Handle, WM_NULL, 0, 0);              { Post a WM_NULL message; this will make sure the menu closes when it loses focus }
    end
  else if (x=WM_LBUTTONDBLCLK) AND (OTFEUnified.active) then
    begin
    case STU_INI_FILE.OptOTFOnDblClk of
      DblClkDismount :
        begin
        OTFCryptoDismountAll(FALSE);
        end;
      DblClkDismountBrutal :
        begin
        OTFCryptoDismountAll(TRUE);
        end;
      DblClkOpenPromptDismount :
        begin
        if OTFEUnified.CountDrivesMounted()=0 then
          begin
          OTFCryptoMountPrompted();
          end
        else
          begin
          OTFCryptoDismountAll(FALSE);
          end;
        end;
      DblClkOpenPromptDismountBrutal :
        begin
        if OTFEUnified.CountDrivesMounted()=0 then
          begin
          OTFCryptoMountPrompted();
          end
        else
          begin
          OTFCryptoDismountAll(TRUE);
          end;
        end;
      DblClkOpenPromptDismountPrompt :
        begin
        if OTFEUnified.CountDrivesMounted()=0 then
          begin
          OTFCryptoMountPrompted();
          end
        else
          begin
          OTFCryptoDismountPrompted();
          end;
        end;
      DblClkOpenPrompt :
        begin
        OTFCryptoMountPrompted();
        end;
      DblClkDismountPrompt :
        begin
        OTFCryptoDismountPrompted();
        end;
    else
      // Display slot information if the tasktray icon is doubleclicked.
      miInformationClick(nil);
    end; // case

    end; // (x=WM_LBUTTONDBLCLK) AND (OTFEUnified.active)

end;

procedure TMain_F.miExitClick(Sender: TObject);
begin
  ExitApp();

end;

procedure TMain_F.miInformationClick(Sender: TObject);
begin
  DisplayVolInfoDlg();

end;

procedure TMain_F.miMountVolumeClick(Sender: TObject);
begin
  OTFCryptoMountPrompted();

end;

procedure TMain_F.miOptionsOTFSystemsClick(Sender: TObject);
var
  optionsForm : TOptionsOTFSystems_F;
  OTFSystemLoop: TOTFESystem;
begin
  if not(IsAModalDialogDisplayed()) then
    begin
    optionsForm := TOptionsOTFSystems_F.Create(nil);
    try
      optionsForm.OTFEUnified := OTFEUnified;
      ModalDialogBeingDisplayed(optionsForm);
      optionsForm.Showmodal();

      // ScramDisk pre-active init...
      TOTFEScramDisk(OTFEUnified.OTFComponents[otfesScramDisk]).useRedScreen := STU_INI_FILE.OptOTFScramDiskUseRedScreen;
      TOTFEScramDisk(OTFEUnified.OTFComponents[otfesScramDisk]).DefaultPromptDir := STU_INI_FILE.OptOTFDefaultBrowseDir;
      TOTFEScramDisk(OTFEUnified.OTFComponents[otfesScramDisk]).PreferredDrive := STU_INI_FILE.OptOTFScramDiskPrefDrive[1];
      TOTFEScramDisk(OTFEUnified.OTFComponents[otfesScramDisk]).HidePasswordsEnteredCk := STU_INI_FILE.OptOTFHidePasswordsEnteredCk;

      // E4M pre-active init...
      TOTFEE4M(OTFEUnified.OTFComponents[otfesE4M]).HidePasswordsEnteredCk := STU_INI_FILE.OptOTFHidePasswordsEnteredCk;
      TOTFEE4M(OTFEUnified.OTFComponents[otfesE4M]).MountDeviceDlg9xStyle := STU_INI_FILE.OptOTFE4MMountDeviceDlg9xStyle;

      // TrueCrypt pre-active init...
      TOTFETrueCrypt(OTFEUnified.OTFComponents[otfesTrueCrypt]).MountDeviceDlg9xStyle := STU_INI_FILE.OptOTFTrueCryptMountDeviceDlg9xStyle;

      // Reset the OTFEUnified component's active status
      OTFEUnified.Active := FALSE;

      for OTFSystemLoop:=low(OTFEUnified.OTFEnabledComponents) to high(OTFEUnified.OTFEnabledComponents) do
        begin
        OTFEUnified.OTFEnabledComponents[OTFSystemLoop] := STU_INI_FILE.OptOTFCryptoSupport[OTFSystemLoop];
        end;
      OTFEUnified.Active := TRUE;


      EnableDisableLaunchMenuitems();
      EnableOTFSystemFunctions(OTFEUnified.active);

      // Setup ScramDisk post-active component options...
      if STU_INI_FILE.OptOTFCryptoSupport[otfesScramDisk] then
        begin
        TOTFEScramDisk(OTFEUnified.OTFComponents[otfesScramDisk]).SetEnableVolumeDeletion(STU_INI_FILE.OptOTFScramDiskDisableSVLProtection);
        end;

      // Setup E4M post-active component options...
      if STU_INI_FILE.OptOTFCryptoSupport[otfesE4M] then
        begin
        if TOTFEE4M(OTFEUnified.OTFComponents[otfesE4M]).VersionCanSupportScramDiskVols() then
          begin
          TOTFEE4M(OTFEUnified.OTFComponents[otfesE4M]).SupportScramDisk := STU_INI_FILE.OptOTFE4MSupportScramDisk;
          end
        else
          begin
          TOTFEE4M(OTFEUnified.OTFComponents[otfesE4M]).SupportScramDisk := FALSE;
          end;
        end;

      // Setup TrueCrypt post-active component options...
      TOTFETrueCrypt(OTFEUnified.OTFComponents[otfesTrueCrypt]).VersionHint := STU_INI_FILE.OptOTFTrueCryptVersionHint;


      TVolumeInfo_F(VolInfoDlg).RefreshDisplay();

      SetupHotKeys();
    finally
      ModalDialogNotBeingDisplayed();
      optionsForm.free;
    end;
    end; // not(IsAModalDialogDisplayed())

end;

procedure TMain_F.miDismountAllNormalClick(Sender: TObject);
begin
  if OTFEUnified.active then
    begin
    OTFCryptoDismountAll(FALSE);
    end;

end;


procedure TMain_F.miDismountAllEmergencyClick(Sender: TObject);
begin
  if OTFEUnified.active then
    begin
    OTFCryptoDismountAll(TRUE);
    end;

end;


procedure TMain_F.SetupHotKeys();
begin
  // Disable all hotkeys.
  DisableHotkey(HKEY_IDENT_DISMOUNT);
  DisableHotkey(HKEY_IDENT_DISMOUNT_BRUTAL);
  DisableHotkey(HKEY_IDENT_SELF_DESTRUCT);
  DisableHotkey(HKEY_IDENT_SCREEN_SAVER);
  DisableHotkey(HKEY_IDENT_EXIT);
  DisableHotkey(HKEY_IDENT_VOLINFO);

  if OTFEUnified.active then
    begin
    if STU_INI_FILE.OptOTFHKeyDismountEnable then
      begin
      EnableHotkey(TextToShortCut(STU_INI_FILE.OptOTFHKeyDismountKey),
                   HKEY_IDENT_DISMOUNT);
      end;

    if STU_INI_FILE.OptOTFHKeyDismountBrutalEnable then
      begin
      EnableHotkey(TextToShortCut(STU_INI_FILE.OptOTFHKeyDismountBrutalKey),
                   HKEY_IDENT_DISMOUNT_BRUTAL);
      end;
    end;

  if (STU_INI_FILE.OptSelfDFacilitiesEnable1 AND
      STU_INI_FILE.OptSelfDFacilitiesEnable2 AND
      STU_INI_FILE.OptSelfDEnableHotkey) then
    begin
    EnableHotkey(TextToShortCut(STU_INI_FILE.OptSelfDHotKey),
                 HKEY_IDENT_SELF_DESTRUCT);
    end;

  if STU_INI_FILE.OptHKeyVolInfoEnable then
    begin
    EnableHotkey(TextToShortCut(STU_INI_FILE.OptHKeyVolInfoKey),
                 HKEY_IDENT_VOLINFO);
    end;

  if STU_INI_FILE.OptHKeyScreenSaverEnable then
    begin
    EnableHotkey(TextToShortCut(STU_INI_FILE.OptHKeyScreenSaverKey),
                 HKEY_IDENT_SCREEN_SAVER);
    end;

  if STU_INI_FILE.OptHKeyExitEnable then
    begin
    EnableHotkey(TextToShortCut(STU_INI_FILE.OptHKeyExitKey),
                 HKEY_IDENT_EXIT);
    end;

end;

procedure TMain_F.EnableHotkey(hotkey : TShortCut; hotkeyIdent : integer);
var
  modifiers : integer;
  vk  : word;
  shiftState : TShiftState;
begin
  if hotkey=TextToShortCut('(None)') then
    begin
    DisableHotkey(hotkeyIdent);
    end
  else
    begin
    // Obtain the virtual keycode and shiftState
    ShortCutToKey(hotkey, vk, shiftState);

    // Convet TShiftState into a modifier value for RegisterHotKey
    modifiers := 0;
    if (ssCtrl in shiftState) then
      begin
      modifiers := modifiers OR MOD_CONTROL;
      end;
    if (ssAlt in shiftState) then
      begin
      modifiers := modifiers OR MOD_ALT;
      end;
    if (ssShift in shiftState) then
      begin
      modifiers := modifiers OR MOD_SHIFT;
      end;

    DisableHotkey(hotkeyIdent);
    if not RegisterHotkey(Handle, hotkeyIdent, modifiers, vk) then
      begin
      ErrorMessage('Error: Unable to assign hotkey '+inttostr(hotkeyIdent));
      end;

    end;

end;

procedure TMain_F.DisableHotkey(hotkeyIdent: integer);
begin
  UnRegisterHotkey(Handle, hotkeyIdent);
end;

procedure TMain_F.WMHotkey(var msg: TWMHotkey);
begin
  if msg.hotkey = HKEY_IDENT_DISMOUNT then
    begin
    if OTFEUnified.active then
      begin
      // We'll allow errors in dismount to be reported to the user; it's just
      // a normal dismount
      OTFCryptoDismountAll(FALSE);
      end;
    end
  else if msg.hotkey = HKEY_IDENT_DISMOUNT_BRUTAL then
    begin
    if OTFEUnified.active then
      begin
      // Panic! The user pressed the emergency dismount hotkey! Better not
      // report any errors to the user
      OTFCryptoDismountAll(TRUE, TRUE);
      end;
    end
  else if msg.hotkey = HKEY_IDENT_VOLINFO then
    begin
    DisplayVolInfoDlg();
    end
  else if msg.hotkey = HKEY_IDENT_SCREEN_SAVER then
    begin
    LaunchScreenSaver();
    end
  else if msg.hotkey = HKEY_IDENT_EXIT then
    begin
    Close;
    end
  else if msg.hotkey = HKEY_IDENT_SELF_DESTRUCT then
    begin
    SelfDestruct();
    end;

end;

procedure TMain_F.SelfDestruct();
var
  volumeFilenames : TStringList;
  i : integer;
  currentTarget: string;
  triggerTestMessage: string;
  mtdDrvs: string;
  currVolFilename: string;
  randomDateTime: SYSTEMTIME;
  currDateTime: TDateTime;
  startDateTime: TDateTime;
  endDateTime: TDateTime;
begin
  if (STU_INI_FILE.OptSelfDFacilitiesEnable1 AND
      STU_INI_FILE.OptSelfDFacilitiesEnable2) then
    begin
    if STU_INI_FILE.OptSelfDTriggerTestMode then
      begin
      triggerTestMessage := 'SELF DESTRUCT TRIGGER ACTIVATED';
      triggerTestMessage := triggerTestMessage+CRLF+CRLF+'A trigger has just been activated. Normally this would cause the self-destruct procedure to be run, but since trigger test mode is currently enabled, this has not happened and instead this dialog was displayed.';
      triggerTestMessage := triggerTestMessage+CRLF+CRLF+'To disable trigger test mode, uncheck the option shown on the "Trigger Test Mode" tab of the self-destruct options screen';
      messagedlg(triggerTestMessage, mtInformation, [mbOK], 0);
      end
    else
      begin
      if STU_INI_FILE.OptSelfDStealth then
        begin
        Shell_NotifyIcon(NIM_DELETE, @TrayIcon);
        // Free up the tasktray icons
        DestroyTaskTrayIcons();
        end;

      if (STU_INI_FILE.OptSelfDRandomizeDT) then
        begin
        currDateTime := Now();
        if STU_INI_FILE.OptSelfDRandomizeDTStartCurrent then
          begin
          startDateTime := currDateTime;
          end
        else
          begin
          startDateTime := STU_INI_FILE.OptSelfDRandomizeDTStart;
          end;

        if STU_INI_FILE.OptSelfDRandomizeDTEndCurrent then
          begin
          endDateTime := currDateTime;
          end
        else
          begin
          endDateTime := STU_INI_FILE.OptSelfDRandomizeDTEnd;
          end;
          
        GetRandomDate(randomDateTime, startDateTime, endDateTime);
        SetSystemTime(randomDateTime);
        end;

      volumeFilenames := TStringList.create;
      try
        // Run user specified executable, if needed
        if STU_INI_FILE.OptSelfDRunAdditionalEnable then
          begin
          winexec(PChar(STU_INI_FILE.OptSelfDRunAdditionalFilename), SW_MINIMIZE);
          end;

        volumeFilenames.clear;
        if OTFEUnified.active then
          begin
          // Make up a list of all drives mounted
          mtdDrvs:= OTFEUnified.DrivesMounted();
          for i:=1 to length(mtdDrvs) do
            begin
            currVolFilename := OTFEUnified.GetVolFileForDrive(mtdDrvs[i]);
            volumeFilenames.add(currVolFilename);
            end; // for each slot

          // Brutal dismount all drives
          OTFCryptoDismountAll(TRUE, TRUE);
          end;

        // If needed, destroy any additional files
        i := 0;
        while i<STU_INI_FILE.OptSelfDTargetFiles.count do
          begin
          currentTarget := STU_INI_FILE.OptSelfDTargetFiles[i];
          if Pos('DIR:', currentTarget)=1 then
            begin
            Delete(currentTarget, 1, 4);
            ShredderObj.DestroyFileOrDir(currentTarget, FALSE, TRUE);
            end
          else if Pos('FILE:', currentTarget)=1 then
            begin
            Delete(currentTarget, 1, 5);
            ShredderObj.DestroyFileOrDir(currentTarget, FALSE, TRUE);
            end
          else if Pos('REGKEY:', currentTarget)=1 then
            begin
            Delete(currentTarget, 1, 7);
            ShredderObj.DestroyRegKey(currentTarget);
            end;

          // Overwrite
          STU_INI_FILE.OptSelfDTargetFiles[i] := 'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX';
          currentTarget := STU_INI_FILE.OptSelfDTargetFiles[i];
          inc(i);
          end;

        // If needed, destroy any mounted files
        if STU_INI_FILE.OptSelfDDestroyMountedEnable then
          begin
          i := 0;
          while i<volumeFilenames.count do
            begin
            ShredderObj.DestroyFileOrDir(volumeFilenames[i], STU_INI_FILE.OptSelfDDestroyMountedQuickShred, TRUE);
            volumeFilenames[i] := 'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX';
            inc(i);
            end;
          end; // destroying mounted drives

      finally
        volumeFilenames.free;
        if STU_INI_FILE.OptSelfDStealth then
          begin
          Close;
          Application.Terminate;
          end;
      end; // try

      end; // trigger test mode was not enabled - this was for real!
    end; // self-destruct facilities were enabled

end;

procedure TMain_F.UpdateTrayIcon();
begin
  TrayIcon.hIcon := hIconUnmounted;

  if OTFEUnified.active then
    begin
    if STU_INI_FILE.OptOTFAlwaysUnmountedIcon then
      begin
      TrayIcon.hIcon := hIconUnmounted;
      end
    else if OTFEUnified.CountDrivesMounted>0 then
      begin
      TrayIcon.hIcon := hIconMounted;
      end;

    end;

  EnableDisableMenuItems();

  if STU_INI_FILE.OptUseTaskTrayIcon then
    begin
    Shell_NotifyIcon(NIM_MODIFY, @TrayIcon);
    end;

end;

procedure TMain_F.ModalDialogNotBeingDisplayed();
begin
  modalDialogDisplayed := nil;
end;

function TMain_F.IsAModalDialogDisplayed() : boolean;
begin
  if modalDialogDisplayed<>nil then
    begin
    SetForeGroundWindow(modalDialogDisplayed.handle);
    end;

  Result := (modalDialogDisplayed<>nil);
end;

procedure TMain_F.ModalDialogBeingDisplayed(theDialog : TForm);
begin
  modalDialogDisplayed := theDialog;
end;

procedure TMain_F.miSelfDestructClick(Sender: TObject);
begin
  SelfDestruct();
end;

procedure TMain_F.EnableDisableMenuItems();
begin
  // Hide/show the "SELF-DESTRUCT" menuitems, and lines next to them,
  // as needed
  miSelfDestruct1.visible     := FALSE;
  miSelfDestruct2.visible     := FALSE;
  if (STU_INI_FILE.OptSelfDFacilitiesEnable1 AND
      STU_INI_FILE.OptSelfDFacilitiesEnable2) then
    begin
    if STU_INI_FILE.OptSelfDEnableMenuitem then
      begin
      miSelfDestruct1.visible     := (STU_INI_FILE.OptSelfDMenuitemLocation=sdmiTop) OR (STU_INI_FILE.OptSelfDMenuitemLocation=sdmiBoth);
      miSelfDestruct2.visible     := (STU_INI_FILE.OptSelfDMenuitemLocation=sdmiBottom) OR (STU_INI_FILE.OptSelfDMenuitemLocation=sdmiBoth);
      end;
    end;
  miSelfDestructLine1.visible := miSelfDestruct1.visible;
  miSelfDestructLine2.visible := miSelfDestruct2.visible;

  miDismount.enabled := FALSE;
  if OTFEUnified.active then
    begin
    miDismount.enabled          := (OTFEUnified.CountDrivesMounted>0);
    end;

  miDismountAllNormal.enabled       := miDismount.enabled;
  miDismountAllEmergency.enabled    := miDismount.enabled;

end;


procedure TMain_F.miOptionsSelfDestructClick(Sender: TObject);
var
  optionsForm : TOptionsSelfD_F;
begin
  if not(IsAModalDialogDisplayed()) then
    begin
    optionsForm := TOptionsSelfD_F.Create(nil);
    try
      ModalDialogBeingDisplayed(optionsForm);
      optionsForm.Showmodal();
      EnableDisableTriggerTestMode();
      EnableDisableSerialSelfDestruct();
      EnableDisableInternetSelfDestruct();
      SetupHotKeys();
    finally
      ModalDialogNotBeingDisplayed();
      optionsForm.free;
    end;
    end; // not(IsAModalDialogDisplayed())

  EnableDisableMenuItems();

end;

procedure TMain_F.miMountPartitionClick(Sender: TObject);
begin
  OTFCryptoMountPartition();

end;

procedure TMain_F.miShredFileClick(Sender: TObject);
var
  confirm: Word;
begin
  if ShredFileDialog.Execute() then
    begin
    confirm := messageDlg('Are you sure you wish to shred file '+ShredFileDialog.Filename+'?', mtConfirmation, [mbYes, mbNo], 0);
    if confirm=mrYes then
      begin
      ShredderObj.DestroyFileOrDir(ShredFileDialog.Filename, FALSE, not(STU_INI_FILE.OptShredIntShowProgress));
      end;
    end;

end;

procedure TMain_F.EnableOTFSystemFunctions(enable: boolean);
begin
  // Hide main OTF System menuitems
  miMountVolume.visible       := enable;
  miDismount.visible          := enable;
  miDismountAllNormal.visible := enable;
  miDismountAllEmergency.visible := enable;
  miInformation.visible       := enable;

  // Hide OTF System menuitems diving lines
  miLineMount.visible         := enable;
  miLineDismount1.visible     := enable;
  miLineDismount2.visible     := enable;

  // Conditional on if possible
  miMountPartition.visible   := ( enable AND OTFEUnified.CanMountDevice());

end;


procedure TMain_F.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if modalDialogDisplayed<>nil then
    begin
    // This is done so that the dialog can be closed. When the timer times out,
    // it will try to close the app again
    modalDialogDisplayed.Close();
    ttCloseTimer.enabled := TRUE;
    CanClose:=FALSE;
    exit;
    end;

  if not(CommandLineOnly) then
    begin
    CanClose := TRUE;

    if STU_INI_FILE<>nil then
      begin
      case STU_INI_FILE.OptOTFOnExit of
        ExitDismount :
          begin
          if OTFEUnified.active then
            begin
            CanClose := OTFCryptoDismountAll(FALSE);
            end;
          end;
        ExitDismountBrutal :
          begin
          if OTFEUnified.active then
            begin
            OTFCryptoDismountAll(TRUE);
            end;
          end;
      end; // case STU_INI_FILE.OptOnExit
    end;

    if CanClose then
      begin
      VolInfoDlg.Free();

      OTFEUnified.Active := FALSE;

      Shell_NotifyIcon(NIM_DELETE, @TrayIcon);

      // Free up the tasktray icons
      DestroyTaskTrayIcons();

      // Close down serial port self-destruct system
      ttSerialSelfDTrigger.enabled := FALSE;
      if COMPortObj<>nil then
        begin
        COMPortObj.Free();
        COMPortObj := nil;
        end;

      if ShredderObj<>nil then
        begin
        ShredderObj.Free();
        ShredderObj := nil;
        end;

      // Close down internet self-destruct system
      if ServerSocket<>nil then
        begin
        ServerSocket.Free();
        ServerSocket:= nil;
        end;

      // If we are supposed to touch files on exit, then do so
      if STU_INI_FILE<>nil then
        begin
        if STU_INI_FILE.OptTouchOnExit then
          begin
          ttTouchFilesTimer(nil);
          end;
        end;
      ttTouchFiles.enabled := FALSE;

      if STU_INI_FILE<>nil then
        begin
        STU_INI_FILE.Free();
        STU_INI_FILE := nil;
        end;

      if WindowsInfo<>nil then
        begin
        WindowsInfo.Free();
        WindowsInfo := nil;
        end;

      Application.Terminate;
      end;

  end;

end;


// NOTE: If command line switches are specified, this instance of SecureTrayUtil
//       will terminate after initialising
//
// Command line switches supported:
//     /mount <volume filename> - prompt for a password, and mount the
//                                  specified volume file
//     /mountpartitions - prompt for a password, and mount partitions
//     /SDmount <volume filename> - see /mount
//     /readonly - (used in with /SDmount) mount the volume file
//                 as read-only
//
//     /shred <file for dir> - shred the given file, using the default shredder
//     /shredfree <driveletter> - shred free space on specified drive (will
//                                also shred slack space if setup in the
//                                internal shredder dialog)
//     /silent - (used in with /shred or /shredfree) do not prompt the user to
//               confirm the operation; operate silently
//
//     /dismount [<driveletter>] - dismount then named drive
//     /brutal - (used with /SDdismount) Dismount brutal
//     /all - (used with /SDdismount) dismount all mounted drives
//     /SDdismount [<driveletter>] - see /dismount
//
//     [/date <date>] [/time <time>] [/promptdatetime] /touch <file or dir>  <file or dir> ... - touch file(s)
//     /hash <filename> - hash specified file
procedure TMain_F.CheckCommandLineParameters();
var
  aFilename: string;
  shredWarning: string;
  fileAttributes : integer;
  volumeFilename: string;
  readonly: boolean;
  confirm: Word;
  switchNumber: integer;
  i: integer;
  driveLetterStr: string;
  silent: boolean;
  cancelCheck: integer;
  drive: string;
  brutal: boolean;
  mounting: boolean;
  dismounting: boolean;
  touchDateTimeStamp: TDateTime;
  strTouchDate: string;
  strTouchTime: string;
  strTouchDateTime: string;
  touchDetailsDlg: TTouchFileSelect_F;
  allOK: boolean;
begin
  allOK := TRUE;

  silent := FALSE;
  if SDUCommandLineSwitch('silent') then
    begin
    silent := TRUE;
    end;

  if OTFEUnified.active then
    begin
    if SDUCommandLineSwitch('mountpartitions') then
      begin
      CommandLineOnly := TRUE;
      OTFCryptoMountPartition();
      end;

    mounting := SDUCommandLineParameter('SDmount', volumeFilename);
    if not(mounting) then
      begin
      mounting := SDUCommandLineParameter('mount', volumeFilename);
      end;

    if mounting then
      begin
      CommandLineOnly := TRUE;

      readonly := FALSE;

      if SDUCommandLineSwitch('readonly') then
        begin
        readonly := TRUE;
        end;

      OTFEUnified.Mount(volumeFilename, readonly);
      end;

    dismounting := SDUCommandLineParameter('SDdismount', drive);
    if not(dismounting) then
      begin
      dismounting := SDUCommandLineParameter('dismount', drive);
      end;

    if dismounting then
      begin
      CommandLineOnly := TRUE;

      brutal := SDUCommandLineSwitch('brutal');

      if lowercase(drive)='all' then
        begin
        // When running from the command line, we don't display a dialog
        // stating success/failure
        OTFCryptoDismountAll(brutal, TRUE);
        end
      else
        begin
        if (drive[1]<>'-') AND (drive[1]<>'/') then
          begin
          OTFEUnified.Dismount(drive[1], brutal);
          end;
        end;

      end;

    end; // OTFEUnified.active

  if SDUCommandLineSwitch('selfdestruct') then
    begin
    CommandLineOnly := TRUE;
    SelfDestruct();
    end;

  if SDUCommandLineParameter('shredfree', driveLetterStr) then
    begin
    CommandLineOnly := TRUE;
    cancelCheck := ShredderObj.OverwriteDriveFreeSpace(driveLetterStr[1], silent);

    if (STU_INI_FILE.OptShredSlack) AND (cancelCheck<>-2) then
      begin
      ShredderObj.OverwriteAllFileSlacks(driveLetterStr[1], silent);
      end;
    end;

  switchNumber := SDUCommandLineSwitchNumber('shred');
  if switchNumber>-1 then
    begin
    CommandLineOnly := TRUE;
    confirm := mrNo;

    for i:=switchNumber+1 to ParamCount do
      begin
      aFilename := ParamStr(i);
      fileAttributes := FileGetAttr(aFilename);
      if fileAttributes=-1 then
        begin
        if not(silent) then
          begin
          messageDlg('Error: File '+aFilename+' not found; cannot delete it.', mtError, [mbOK], 0);
          end;
        end
      else
        begin
        if (fileAttributes AND faDirectory)<>0 then
          begin
          shredWarning := 'directory';
          end
        else
          begin
          shredWarning := 'file';
          end;

        aFilename := SDUConvertSFNToLFN(aFilename);
        shredWarning := 'About to shred ' + shredWarning + ' ' + aFilename + '.' + CRLF + CRLF + 'Do you wish to continue?';

        if silent then
          begin
          confirm := mrYes;
          end
        else if (confirm<>mrYesToAll) AND
                (confirm<>mrNoToAll)  AND
                (confirm<>mrCancel) then
          begin
          confirm := messageDlg(shredWarning, mtWarning, [mbYes, mbNo, mbYesToAll, mbCancel], 0);
          end;

        if (confirm=mrYes) OR
           (confirm=mrYesToAll) then
          begin
          ShredderObj.DestroyFileOrDir(aFilename, FALSE, silent);
          end;
        end; // fileAttributes<>-1
      end; // for each file to be shredded
  end;

  switchNumber := SDUCommandLineSwitchNumber('touch');
  if switchNumber>-1 then
    begin
    CommandLineOnly := TRUE;

    if not(SDUCommandLineParameter('date', strTouchDate)) then
      begin
      strTouchDate := DateToStr(Date());
      end;
    if not(SDUCommandLineParameter('time', strTouchTime)) then
      begin
      strTouchTime := TimeToStr(Time());
      end;

    touchDateTimeStamp := Now(); // Gets rid of compiler warning
    strTouchDateTime := strTouchDate + ' ' + strTouchTime;
    try
      touchDateTimeStamp := StrToDateTime(strTouchDateTime);
    except
     on EConvertError do
       begin
       // xxx - This should be displayed on the console, NOT the the Windows display
       MessageDlg('Invalid date/time entered', mtError, [mbOK], 0);
       allOK := FALSE;
       end;
    end;

    if SDUCommandLineSwitch('promptdatetime') then
      begin
      touchDetailsDlg:= TTouchFileSelect_F.create(nil);
      try
        aFilename := '';
        for i:=switchNumber+1 to ParamCount do
          begin
          aFilename := aFilename + SDUConvertSFNToLFN(ParamStr(i)) + ' ';
          end;

        touchDetailsDlg.WarnOnNonExistantFile := FALSE;
        SDUEnableControl(touchDetailsDlg.edFilename, FALSE);
        SDUEnableControl(touchDetailsDlg.pbBrowseFile, FALSE);
        SDUEnableControl(touchDetailsDlg.pbBrowseDir, FALSE);
        touchDetailsDlg.edFilename.text := aFilename;
        touchDetailsDlg.DateTimeAsString := strTouchDateTime;
        if not(touchDetailsDlg.ShowModal()=mrOK) then
          begin
          allOK := FALSE;
          end
        else
          begin
          if touchDetailsDlg.DateTimeAsString='' then
            begin
            touchDateTimeStamp := Now();
            end
          else
            begin
            touchDateTimeStamp := StrToDateTime(touchDetailsDlg.DateTimeAsString);
            end;

          end;
      finally
        touchDetailsDlg.Free();
      end;
      end;

    if allOK then
      begin
      for i:=switchNumber+1 to ParamCount do
        begin
        aFilename := ParamStr(i);
        if (not(FileExists(aFilename)) and not(DirectoryExists(aFilename))) then
          begin
          if not(silent) then
            begin
            messageDlg('Error: File/dir '+aFilename+' not found; cannot touch it.', mtError, [mbOK], 0);
            end;
          end
        else
          begin
          aFilename := SDUConvertSFNToLFN(aFilename);
          TouchFileOrDir(aFilename, touchDateTimeStamp);
          end; // if not(FileExists(aFilename) then
        end; // for each file to be touched
      end;
  end;

  if SDUCommandLineParameter('hash', drive) then
    begin
    CommandLineOnly := TRUE;
    CommandLineHashFile();
    end;

  if SDUCommandLineSwitch('stayloaded') then
    begin
    CommandLineOnly := FALSE;
    StayLoaded := TRUE;
    end;
end;


procedure TMain_F.miShredDirClick(Sender: TObject);
var
  dirToShred: string;
  confirm: Word;
begin
  if SelectDirectory('Select directory to shred', '', dirToShred) then
    begin
    confirm := messageDlg('Are you sure you wish to shred directory '+dirToShred+'?', mtConfirmation, [mbYes, mbNo], 0);
    if confirm=mrYes then
      begin
      ShredderObj.DestroyFileOrDir(dirToShred, FALSE, not(STU_INI_FILE.OptShredIntShowProgress));
      end;
    end;

end;


procedure TMain_F.miOptionsGeneralClick(Sender: TObject);
var
  optionsForm : TOptionsGeneral_F;
begin
  if not(IsAModalDialogDisplayed()) then
    begin
    optionsForm := TOptionsGeneral_F.Create(nil);
    try
      ModalDialogBeingDisplayed(optionsForm);
      optionsForm.Showmodal();
      
      SetupShredderObj();
      SetupHotKeys();
      LoadTaskTrayIcons();
      UpdateTrayIcon();
      AddOrRemoveTrayIcon();
      TVolumeInfo_F(VolInfoDlg).RefreshDisplay();

      ttTouchFiles.interval := STU_INI_FILE.OptTouchFrequency*1000;
      ttTouchFiles.enabled := STU_INI_FILE.OptTouchRegularly;
    finally
      ModalDialogNotBeingDisplayed();
      optionsForm.free;
    end;
    end; // not(IsAModalDialogDisplayed())

  EnableDisableMenuItems();

end;


procedure TMain_F.DestroyRegKey(key: string);
var
  registry: TRegistry;
  NTsubkeys: TStrings;
  rootStr: string;
  i: integer;
begin
  registry := TRegistry.create();
  try
    if Pos('HKCR\', key)=1 then
      begin
      registry.RootKey := HKEY_CLASSES_ROOT;
      end
    else if Pos('HKCU\', key)=1 then
      begin
      registry.RootKey := HKEY_CURRENT_USER;
      end
    else if Pos('HKLM\', key)=1 then
      begin
      registry.RootKey := HKEY_LOCAL_MACHINE;
      end
    else if Pos('HKU \', key)=1 then
      begin
      registry.RootKey := HKEY_USERS;
      end
    else if Pos('HKCC\', key)=1 then
      begin
      registry.RootKey := HKEY_CURRENT_CONFIG;
      end
    else if Pos('HKDD\', key)=1 then
      begin
      registry.RootKey := HKEY_DYN_DATA;
      end;

    rootStr := Copy(key, 1, 5);
    Delete(key, 1, 5);

    if (Win32Platform=VER_PLATFORM_WIN32_NT) then
      begin
      NTsubkeys:=TStringList.Create();
      try
        if registry.OpenKey(key, FALSE) then
          begin
          if registry.HasSubkeys() then
            begin
            registry.GetKeyNames(NTsubkeys);
            end;
          registry.CloseKey();
          
          for i:=0 to (NTsubkeys.count-1) do
            begin
            DestroyRegKey(rootStr+NTsubkeys[i]);
            end;
          end;
      finally
        NTsubkeys.Free();
      end;
      end;

    registry.DeleteKey(key);
  finally
    registry.Free();
  end;

end;


procedure TMain_F.LaunchScreenSaver();
var
  iniFile: TIniFile;
  screenSaverCmd: string;
begin
  iniFile := TIniFile.Create('system.ini');
  try
    screenSaverCmd := iniFile.ReadString('boot', 'SCRNSAVE.EXE', '');
    if screenSaverCmd<>'' then
      begin
      screenSaverCmd := screenSaverCmd + ' /S';
      WinExec(PChar(screenSaverCmd), SW_RESTORE);
      end;
  finally
    iniFile.Free();
  end;

end;

procedure TMain_F.InitApp();
begin
  EnableOTFSystemFunctions(OTFEUnified.active);

  EnableDisableLaunchMenuitems();

  LoadTaskTrayIcons();

  TrayIcon.cbSize := SizeOf(TrayIcon);        { This is required }
  TrayIcon.Wnd := Self.Handle;                { The handle to your main window }
  TrayIcon.uId := 0;
  TrayIcon.uFlags := NIF_ICON or NIF_TIP or NIF_MESSAGE;
  TrayIcon.uCallBackMessage := WM_MOUSEMOVE;  { The message the icon answers to }
  TrayIcon.hIcon := hIconUnsure;         { The handle of the icon to display }
  TrayIcon.szTip := 'SecureTrayUtil';     { The bubble help of the icon }

  if STU_INI_FILE.OptOTFAlwaysUnmountedIcon then
    begin
    TrayIcon.hIcon := hIconUnmounted;
    end;

  AddOrRemoveTrayIcon();
  UpdateTrayIcon();

  SetupHotKeys();
  EnableDisableMenuItems();

  if STU_INI_FILE.OptOTFMountVolStart then
    begin
    OTFCryptoMountPrompted();
    end;

  if STU_INI_FILE.OptOTFMountPartStart then
    begin
    OTFCryptoMountPartition();
    end;

  WindowsInfo := TWindowsInfo.Create();

end;

procedure TMain_F.ttSerialSelfDTriggerTimer(Sender: TObject);
begin
  if COMPortObj.Active then
    begin
    if not(COMPortObj.Test()) then
      begin
      ttSerialSelfDTrigger.enabled := FALSE;
      SelfDestruct();
      end;
    end;

end;

procedure TMain_F.EnableDisableSerialSelfDestruct();
var
  portNumberAsString: string;
begin
  ttSerialSelfDTrigger.enabled := FALSE;
  if (STU_INI_FILE.OptSelfDTriggerPortEnable) AND
     (STU_INI_FILE.OptSelfDFacilitiesEnable1) AND
     (STU_INI_FILE.OptSelfDFacilitiesEnable2) then
    begin
    portNumberAsString := STU_INI_FILE.OptSelfDTriggerPort[length(STU_INI_FILE.OptSelfDTriggerPort)];
    if COMPortObj.SetupCOMPort(strtoint(portNumberAsString)) then
      begin
      ttSerialSelfDTrigger.interval := STU_INI_FILE.OptSelfDTriggerPortInterval;
      ttSerialSelfDTrigger.enabled := TRUE;
      end
    else
      begin
      MessageDlg(
                 'Failed to setup '+STU_INI_FILE.OptSelfDTriggerPort+' - port self destruct trigger not active',
                 mtWarning,
                 [mbOK],
                 0
                );
      end;
    end
  else
    begin
    COMPortObj.CloseCOMPort();
    end;

end;

procedure TMain_F.EnableDisableInternetSelfDestruct();
begin
  if ServerSocket<>nil then
    begin
    ServerSocket.Close;
    ServerSocket.Free();
    ServerSocket := nil;
    end;

  if (STU_INI_FILE.OptSelfDEnableInternetTrigger) AND
     (STU_INI_FILE.OptSelfDFacilitiesEnable1)     AND
     (STU_INI_FILE.OptSelfDFacilitiesEnable2)     then
    begin
    ServerSocket:= TServerSocket.Create(nil);

    ServerSocket.Port := STU_INI_FILE.OptSelfDInternetPort;

    ServerSocket.ServerType := stNonBlocking;
    ServerSocket.ThreadCacheSize := 10;

    ServerSocket.OnClientConnect    := ServerSocketClientConnect;
    ServerSocket.OnClientDisconnect := ServerSocketClientDisconnect;
    ServerSocket.OnClientError      := ServerSocketClientError;
    ServerSocket.OnClientRead       := ServerSocketClientRead;

    try
      ServerSocket.Open;
    except
     on ESocketError do
       begin
       MessageDlg('Windows socket error: Unable to activate self-destruct via internet facilities'+#13+#10+
                    #13+#10+
                    'Please check settings and confirm that the port number specified for use with self-destruct ('+inttostr(STU_INI_FILE.OptSelfDInternetPort)+') is correct, and not in use by any other application',
                  mtError, [mbOK], 0);

       MessageDlg('WARNING: Self-destruct via the internet functionality is currently DISABLED', mtWarning, [mbOK], 0);
       ServerSocket.Close;
       ServerSocket.Free();
       ServerSocket := nil;
       end;
    end;

    end;

end;

procedure TMain_F.EnableDisableTriggerTestMode();
begin
  if STU_INI_FILE.OptSelfDTriggerTestMode then
    begin
    // The timer is automatically enabled by this call
    ttTriggerTestModeWarningTimer(nil);
    end
  else
    begin
    ttTriggerTestModeWarning.enabled := FALSE;
    end;

end;


procedure TMain_F.ttTriggerTestModeWarningTimer(Sender: TObject);
var
  triggerTestMessage: string;
begin
    ttTriggerTestModeWarning.enabled := FALSE;
    triggerTestMessage := 'TRIGGER TEST MODE IS ACTIVE';
    triggerTestMessage := triggerTestMessage+CRLF+CRLF+'In this mode, whenever a self-destruct trigger is activated, a dialog will appear on the screen telling you so; self destruct will NOT be carried out.';
    triggerTestMessage := triggerTestMessage+CRLF+CRLF+'This dialog will appear once every two minutes while this mode is active';
    triggerTestMessage := triggerTestMessage+CRLF+CRLF+'To disable trigger test mode, uncheck the option shown on the "Trigger Test Mode" tab of the self-destruct options screen';
    messagedlg(triggerTestMessage, mtWarning, [mbOK], 0);
    ttTriggerTestModeWarning.enabled := TRUE;

end;


procedure TMain_F.miShredFreeSpaceClick(Sender: TObject);
var
  drvSelectDlg: TDriveSelect_F;
  cancelCheck: integer;
begin
  if not(IsAModalDialogDisplayed()) then
    begin
    drvSelectDlg:= TDriveSelect_F.Create(nil);
    try
      ModalDialogBeingDisplayed(drvSelectDlg);
      if drvSelectDlg.Showmodal()=mrOK then
        begin
        cancelCheck := ShredderObj.OverwriteDriveFreeSpace(drvSelectDlg.dcvShredFreeDrive.drive);

        if (STU_INI_FILE.OptShredSlack) AND (cancelCheck<>-2) then
          begin
          ShredderObj.OverwriteAllFileSlacks(drvSelectDlg.dcvShredFreeDrive.drive);
          end;
        end;
    finally
      ModalDialogNotBeingDisplayed();
      drvSelectDlg.Free();
    end;
    end; // not(IsAModalDialogDisplayed())

end;


// Attempt to mount the volume filenames specified
// This function can be called from outside this object
// Note: Returns a string containing drive letters for those volumes that were
// successfully mounted, and #0 for those volume files that could not be mounted
function TMain_F.OTFCryptoMountUnPrompted(volFiles: TStringList; readOnly: boolean): string;
var
  volsMountedAs: string;
  i: integer;
  areAnyVolFiles: boolean;
  finished: boolean;
begin
  Result := '';

  volsMountedAs := '';
  areAnyVolFiles := FALSE;

  if OTFEUnified.active then
    begin
    // First, check that we have been supplied with at least one valid volume
    // file
    for i:=0 to (volFiles.count-1) do
      begin
      areAnyVolFiles := areAnyVolFiles OR OTFEUnified.IsEncryptedVolFile(volFiles[i]);
      end;
    if not(areAnyVolFiles) then
      begin
      MessageDlg('File(s) selected are not encrypted volume file(s)', mtError, [mbOK], 0);
      exit;
      end;


    finished:= FALSE;
    while not(finished) do
      begin
      finished := OTFEUnified.Mount(volFiles, volsMountedAs, readOnly);

      if not(finished) then
        begin
        finished := (OTFEUnified.LastErrorCode<>OTFE_ERR_WRONG_PASSWORD);
        if OTFEUnified.LastErrorCode=OTFE_ERR_WRONG_PASSWORD then
          begin
          MessageDlg('Wrong passsword entered; try again', mtError, [mbOK], 0);
          end;
        end;

      end;


    Result := volsMountedAs;

    if volsMountedAs<>'' then
      begin
      for i:=1 to length(volsMountedAs) do
        begin
        if STU_INI_FILE.OptOTFExploreAfterMount then
          begin
          if volsMountedAs[i]<>#0 then
            begin
            LaunchExplorer(volsMountedAs[i]);
            end
          else
            begin
            if OTFEUnified.LastErrorCode<>OTFE_ERR_USER_CANCEL then
              begin
              MessageDlg('Failed to mount "'+volFiles[i]+'"', mtWarning, [mbOK], 0);
              end;
            end;
          end;
        end;
      end;

    end;


  // Launch any user-specified post-mount program
  for i:=1 to length(Result) do
    begin
    if ((Result[i]<>#0) and (STU_INI_FILE.OptOTFPostMountExe<>'')) then
      begin
      PrePostMountDismountExec('Post-mount', Result[i]+':'+STU_INI_FILE.OptOTFPostMountExe, FALSE);
      end;
    end;


  // Setup display correctly
  RefreshDisplayAndTrayIcon();
  for i:=1 to length(Result) do
    begin
    if Result[i]<>#0 then
      begin
      TVolumeInfo_F(volInfoDlg).SelectDrive(Result[i]);
      break;
      end;
    end;

end;


// This function just prompts the user for a volume filename, and mounts it
// This function can be called from outside this object
// Note: Returns a string containing drive letters for those volumes that were
// successfully mounted, and #0 for those volume files that could not be mounted
// Returns an empty string on failure (e.g. at least one filename was not a
// valid volume; can still return #0#0#0#0#0, or similar if the failure was in
// the actual mounting of the drives)
function TMain_F.OTFCryptoMountPrompted(): string;
var
  volsMountedAs: string;
  mountFilenameDlg: TOpenDialog;
  prevDir: string;
begin
  volsMountedAs := '';

  if OTFEUnified.active then
    begin
    mountFilenameDlg := TOpenDialog.Create(nil);
    try
      mountFilenameDlg.Options := [ofFileMustExist, ofPathMustExist, ofAllowMultiSelect];
      mountFilenameDlg.InitialDir := '\';
      GetDir(0, prevDir);
      // Note: If the user specified default browse dir is invalid, we are
      // defaulted to "My Documents"
      if (STU_INI_FILE.OptOTFDefaultBrowseDir<>'') then
        begin
        mountFilenameDlg.InitialDir := STU_INI_FILE.OptOTFDefaultBrowseDir;
        end;
      mountFilenameDlg.Filter := FILTER_OTFVOLUMEFILES;
      mountFilenameDlg.FilterIndex := STU_INI_FILE.OptOTFDefaultBrowseFilter;
      mountFilenameDlg.Title := 'Mount Volume';

      if (mountFilenameDlg.Execute()) then
        begin
        volsMountedAs := OTFCryptoMountUnPrompted(TStringList(mountFilenameDlg.files), (ofReadOnly in mountFilenameDlg.Options));
        end;

      // Make sure that we don't end up with the CWD being the dir in
      // which volume files are stored - we don't want someone to come along
      // after we've dismounted the volumes and find out where they were kept!
      ChDir(prevDir);

    finally
      mountFilenameDlg.Free();
    end;

    end;

  Result := volsMountedAs;
end;


procedure TMain_F.OTFCryptoDismountPrompted();
var
  dismountDlg: TDismountVolumes_F;
begin
  if not(IsAModalDialogDisplayed()) then
    begin
    if OTFEUnified.active then
      begin
      if OTFEUnified.CountDrivesMounted()<1 then
        begin
        MessageDlg('No volume files mounted', mtInformation, [mbOK], 0);
        end
      else
        begin
        dismountDlg:= TDismountVolumes_F.Create(nil);
        try
          ModalDialogBeingDisplayed(dismountDlg);
          dismountDlg.OTFEUnified := self.OTFEUnified;
          dismountDlg.showmodal();
        finally
          ModalDialogNotBeingDisplayed();
          dismountDlg.Free();
        end;
        end;

      end;

    end; // not(IsAModalDialogDisplayed())

  RefreshDisplayAndTrayIcon();

end;


procedure TMain_F.miDismountClick(Sender: TObject);
begin
  OTFCryptoDismountPrompted();

end;

procedure TMain_F.ServerSocketClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);
var
  psktInfo: pTsocketInfo;
begin
  new(psktInfo);
  psktInfo.chalNum := 0;
  psktInfo.currLine := '';
  Socket.data := psktInfo;
  SendChallengeToSocket(Socket);

end;

procedure TMain_F.ServerSocketClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  dispose(Socket.data);

end;

procedure TMain_F.ServerSocketClientError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
  pTsocketInfo(Socket.data).chalNum:=0;
  pTsocketInfo(Socket.data).currLine:='';
  Socket.Close;

end;

procedure TMain_F.ServerSocketClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
var
  aChar: char;
begin
  while ServerSocket.Active AND (Socket.ReceiveBuf(aChar, 1)>0) do
    begin
    if aChar=#10 then
      begin
      // Nothing
      end
    else if aChar=#255 then
      begin
      Socket.ReceiveBuf(aChar, 1);
      Socket.ReceiveBuf(aChar, 1);
      aChar := #255;
      end
    else if aChar=#13 then
      begin
      if STU_INI_FILE.OptSelfDInternetResp[pTsocketInfo(Socket.data).chalNum] <> pTsocketInfo(Socket.data).currLine then
        begin
        // ABORT - user did not enter correct response
        pTsocketInfo(Socket.data).chalNum := 0;
        Socket.Close;
        end
      else
        begin
        pTsocketInfo(Socket.data).currLine := '';
        inc(pTsocketInfo(Socket.data).chalNum);
        if pTsocketInfo(Socket.data).chalNum>=STU_INI_FILE.OptSelfDInternetCRPairs then
          begin
          // Disconnect
          Socket.Close;
          // Shut down the server - we don't really need to be interrupted for
          // the next bit!
          ServerSocket.Close;

          // SELF DESTRUCT HERE
          SelfDestruct();
          // SELF DESTRUCT HERE
          end
        else
          begin
          SendChallengeToSocket(Socket);
          end;

        end;

      end
    else if (aChar=#8)   OR
            (aChar=#127) then
      begin
      Delete(pTsocketInfo(Socket.data).currLine, length(pTsocketInfo(Socket.data).currLine), 1);
      end
    else
      begin
      pTsocketInfo(Socket.data).currLine := pTsocketInfo(Socket.data).currLine + aChar;
      end;
  end;

end;

procedure TMain_F.SendChallengeToSocket(socket: TCustomWinSocket);
var
  i: integer;
  strSend: string;
begin
  strSend := STU_INI_FILE.OptSelfDInternetChal[pTsocketInfo(socket.data).chalNum];
  for i:=1 to length(strSend)-1 do
    begin
    if (strSend[i]='^') AND (strSend[i+1]='[') then
      begin
      delete(strSend, i, 1);
      strSend[i]:=#27;
      end;
    end;

  socket.SendText(strSend);
end;


procedure TMain_F.ttTouchFilesTimer(Sender: TObject);
begin
  ttTouchFiles.enabled := FALSE;

  TouchTargetFiles();

  ttTouchFiles.enabled := STU_INI_FILE.OptTouchRegularly;
end;

procedure TMain_F.TouchTargetFiles();
var
  i: integer;
  currentTarget: TTouchFileTarget;
  setDateTime: TDateTime;
begin
  ttTouchFiles.enabled := FALSE;

  for i:=0 to (STU_INI_FILE.OptTouchTargetFiles.count-1) do
    begin
    currentTarget := TTouchFileTarget(STU_INI_FILE.OptTouchTargetFiles.objects[i]);

    setDateTime := now;
    if not(currentTarget.useCurrentDateTime) then
      begin
      setDateTime := currentTarget.dateTime;
      end;

    if currentTarget.filename<>'' then
      begin
      TouchFileOrDir(currentTarget.filename, setDateTime);
      end;
    end;

  ttTouchFiles.enabled := STU_INI_FILE.OptTouchRegularly;
end;

function TMain_F.TouchFile(filename: string; dateTimeStamp: TDateTime): boolean;
var
  fileHandle : THandle;
  origFileAttributes : integer;
  newFileAttributes : integer;
begin
  Result := FALSE;

  if fileexists(filename) then
    begin
    // Remove any file attribs, and record the original attribs...
    origFileAttributes := FileGetAttr(filename);
    newFileAttributes := origFileAttributes;
    newFileAttributes := newFileAttributes AND not(faReadOnly);
    newFileAttributes := newFileAttributes AND not(faHidden);
    newFileAttributes := newFileAttributes AND not(faSysFile);
    FileSetAttr(filename, newFileAttributes);

    fileHandle := CreateFile(PChar(filename),
                             GENERIC_READ or GENERIC_WRITE,
                             0,
                             nil,
                             OPEN_EXISTING,
                             FILE_ATTRIBUTE_NORMAL or FILE_FLAG_WRITE_THROUGH,
                             0);

    if fileHandle<>INVALID_HANDLE_VALUE then
      begin
      FileSetDate(fileHandle, DateTimeToFileDate(dateTimeStamp));
      CloseHandle(fileHandle);

      Result := TRUE;
      end;

    // Restore the original file attributes...
    FileSetAttr(filename, origFileAttributes);

    end;
end;


function TMain_F.TouchFileOrDir(fileOrDir: string; dateTimeStamp: TDateTime): boolean;
var
  fileAttributes : integer;
  fileIterator: TSDUFileIterator;
  currFile: string;
  retVal: boolean;
begin
  retVal := TRUE;
  fileAttributes := FileGetAttr(fileOrDir);

  if (fileAttributes AND faDirectory)=0 then
    begin
    retVal := TouchFile(fileOrDir, dateTimeStamp);
    end
  else
    begin
    fileIterator := TSDUFileIterator.Create(nil);
    try
      fileIterator.Directory := fileOrDir;
      fileIterator.RecurseSubDirs := TRUE;
      fileIterator.IncludeDirNames := TRUE;
      fileIterator.OmitStartDirPrefix := FALSE;
      fileIterator.Reset();

      currFile := fileIterator.Next();
      while currFile<>'' do
        begin
        retVal := retVal AND TouchFile(currFile, dateTimeStamp);
        currFile := fileIterator.Next();
        end;

    finally
      fileIterator.Free();
    end;

    end;

  Result := retVal;

end;


procedure TMain_F.WMQueryEndSession(var Msg : TWMQueryEndSession);
begin
  if OTFEUnified.active then
    begin
// xxx - sort this out - it would probably be neater if this just called
//       FormCloseQuery(...)
//    OTFCryptoDismountAll(FALSE);

    OTFEUnified.active := FALSE;
    end;

  // OK, now permit shutdown
  Msg.Result := 1;

end;

procedure TMain_F.WMEndSession(var Msg : TWMEndSession);
begin
  if OTFEUnified.active then
    begin
// xxx - sort this out - it would probably be neater if this just called
//       FormCloseQuery(...)
//    OTFCryptoDismountAll(FALSE);

    OTFEUnified.active := FALSE;
    end;

  // OK, now permit shutdown
  Msg.Result := 1;

end;

procedure TMain_F.miLaunchScramDiskClick(Sender: TObject);
begin
  if (WinExec(PChar(STU_INI_FILE.OptOTFScramDiskExe), SW_RESTORE))<31 then
    begin
    ErrorMessage('Error running ScramDisk; please ensure correct filename and path have been entered in the Options dialog');
    end;

end;

procedure TMain_F.miLaunchE4MClick(Sender: TObject);
begin
  if (WinExec(PChar(STU_INI_FILE.OptOTFE4MExe), SW_RESTORE))<31 then
    begin
    ErrorMessage('Error running E4M; please ensure correct filename and path have been entered in the Options dialog');
    end;

end;

procedure TMain_F.miLaunchBestCryptClick(Sender: TObject);
var
  appExe: string;
begin
  appExe := OTFEUnified.OTFComponents[otfesBestCrypt].GetMainExe();
  if (WinExec(PChar(appExe), SW_RESTORE))<31 then
    begin
    ErrorMessage('Error running BestCrypt; application not found at "'+appExe+'"');
    end;

end;

procedure TMain_F.miLaunchPGPDiskClick(Sender: TObject);
var
  appExe: string;
begin
  appExe := OTFEUnified.OTFComponents[otfesPGPDisk].GetMainExe();
  if (WinExec(PChar(appExe), SW_RESTORE))<31 then
    begin
    ErrorMessage('Error running PGPDisk; application not found at "'+appExe+'"');
    end;

end;

procedure TMain_F.EnableDisableLaunchMenuitems();
var
  menuItemEnabled: boolean;
begin
  menuItemEnabled:= FALSE;

  miLaunchBestCrypt.visible := FALSE;
  if OTFEUnified.OTFEnabledComponents[otfesBestCrypt] then
    begin
    miLaunchBestCrypt.visible := (OTFEUnified.OTFComponents[otfesBestCrypt].GetMainExe()<>'');
    menuItemEnabled:= miLaunchBestCrypt.visible;
    end;

  miLaunchCrossCrypt.visible := FALSE;
  if (STU_INI_FILE.OptOTFCrossCryptExe<>'') AND
     OTFEUnified.OTFEnabledComponents[otfesCrossCrypt] then
    begin
    miLaunchCrossCrypt.visible := TRUE;
    menuItemEnabled:= TRUE;
    end;

  miLaunchE4M.visible := FALSE;
  if (STU_INI_FILE.OptOTFE4MExe<>'') AND
     OTFEUnified.OTFEnabledComponents[otfesE4M] then
    begin
    miLaunchE4M.visible := TRUE;
    menuItemEnabled:= TRUE;
    end;

  miLaunchFreeOTFE.visible := FALSE;
  if (STU_INI_FILE.OptOTFFreeOTFEExe<>'') AND
     OTFEUnified.OTFEnabledComponents[otfesFreeOTFE] then
    begin
    miLaunchFreeOTFE.visible := TRUE;
    menuItemEnabled:= TRUE;
    end;

  miLaunchPGPDisk.visible := FALSE;
  if OTFEUnified.OTFEnabledComponents[otfesPGPDisk] then
    begin
    miLaunchPGPDisk.visible := (OTFEUnified.OTFComponents[otfesPGPDisk].GetMainExe()<>'');
    menuItemEnabled:= miLaunchPGPDisk.visible;
    end;

  miLaunchScramDisk.visible := FALSE;
  if (STU_INI_FILE.OptOTFScramDiskExe<>'') AND
     OTFEUnified.OTFEnabledComponents[otfesScramDisk] then
    begin
    miLaunchScramDisk.visible := TRUE;
    menuItemEnabled:= TRUE;
    end;

  miLaunchTrueCrypt.visible := FALSE;
  if OTFEUnified.OTFEnabledComponents[otfesTrueCrypt] then
    begin
    miLaunchTrueCrypt.visible := (OTFEUnified.OTFComponents[otfesTrueCrypt].GetMainExe()<>'');
    menuItemEnabled:= miLaunchTrueCrypt.visible;
    end;

  miLaunch.visible := menuItemEnabled;


  // Now setup the common launch menuitems...
  miCommonLaunch.visible          := miLaunch.visible;
  miCommonLaunchBestCrypt.visible := miLaunchBestCrypt.visible;
  miCommonLaunchCrossCrypt.visible:= miLaunchCrossCrypt.visible;
  miCommonLaunchE4M.visible       := miLaunchE4M.visible;
  miCommonLaunchFreeOTFE.visible  := miLaunchFreeOTFE.visible;
  miCommonLaunchPGPDisk.visible   := miLaunchPGPDisk.visible;
  miCommonLaunchScramDisk.visible := miLaunchScramDisk.visible;
  miCommonLaunchTrueCrypt.visible := miLaunchTrueCrypt.visible;

end;


// Mount OTFE partitions
function TMain_F.OTFCryptoMountPartition(): string;
var
  retVal: string;
  i: integer;
begin
  retVal := '';

  if OTFEUnified.CanMountDevice() then
    begin
    retVal := OTFEUnified.MountDevices();
    end
  else
    begin
    MessageDlg('There are no OTFE systems enabled that can mount devices.', mtError, [mbOK], 0);
    end;


  // Start up MS Explorers, if appropriate...
  if (retVal<>'') AND (STU_INI_FILE.OptOTFExploreAfterMount) then
    begin
    for i:=1 to length(retVal) do
      begin
      if retVal[i]<>#0 then
        begin
        LaunchExplorer(retVal[i]);
        end
      end;
    end;

  // Launch any user-specified post-mount program...
  for i:=1 to length(retVal) do
    begin
    if ((retVal[i]<>#0) and (STU_INI_FILE.OptOTFPostMountExe<>'')) then
      begin
      PrePostMountDismountExec('Post-mount', retVal[i]+':'+STU_INI_FILE.OptOTFPostMountExe, FALSE);
      end;
    end;


  // Setup display correctly
  RefreshDisplayAndTrayIcon();
  for i:=1 to length(retVal) do
    begin
    if retVal[i]<>#0 then
      begin
      // Select the first drive it can...
      TVolumeInfo_F(volInfoDlg).SelectDrive(retVal[i]);
      break;
      end;
    end;

  Result := retVal;
end;


procedure TMain_F.LoadTaskTrayIcons();
begin
  if hIconMounted<>0 then
    begin
    DestroyTaskTrayIcons();
    end;

  hIconUnmounted := LoadImage(hInstance, PChar(RES_ICON_NAMES[STU_INI_FILE.OptTaskTrayIconUnmounted]), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
  hIconMounted   := LoadImage(hInstance, PChar(RES_ICON_NAMES[STU_INI_FILE.OptTaskTrayIconMounted]), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
  hIconUnsure    := LoadImage(hInstance, PChar(RES_ICON_NAMES[STU_INI_FILE.OptTaskTrayIconUnsure]), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);

end;

procedure TMain_F.DestroyTaskTrayIcons();
begin
  DestroyIcon(hIconMounted);
  DestroyIcon(hIconUnmounted);
  DestroyIcon(hIconUnsure);

end;

function TMain_F.OTFCryptoDismountDrive(drive: char; emergency: boolean): boolean;
var
  finished: boolean;
  confirm: WORD;
begin
  Result := FALSE;

  if STU_INI_FILE.OptConfirmOnDismount then
    begin
    confirm := MessageDlg('Are you sure you wish to dismount drive '+
                           drive+
                           ':?',
                          mtConfirmation,
                          [mbYes, mbNo],
                          -1);
    end
  else
    begin
    confirm := mrYes;
    end;

  if confirm=mrYes then
    begin
    finished:= FALSE;
    while not(finished) do
      begin
      // Launch any user-specified pre-dismount program
      if (STU_INI_FILE.OptOTFPreDismountExe<>'') then
        begin
        PrePostMountDismountExec('Pre-dismount', drive+':'+STU_INI_FILE.OptOTFPreDismountExe, TRUE);
        end;

      if OTFEUnified.Dismount(drive, emergency) then
        begin
        // Launch any user-specified post-dismount program
        PrePostMountDismountExec('Post-dismount', STU_INI_FILE.OptOTFPostDismountExe, FALSE);

        finished := TRUE;
        Result := TRUE;
        end
      else
        begin
        if ReportDismountFailure(drive) then
          begin
          emergency := TRUE;
          end
        else
          begin
          finished := TRUE;
          end;
        end;
      end;
    end;

  RefreshDisplayAndTrayIcon();
  TVolumeInfo_F(volInfoDlg).SelectFirstMtdDrive();

end;


function TMain_F.OTFCryptoDismountAll(emergency: boolean; supressErrors: boolean = FALSE): boolean;
var
  dmntFailDrvs: string;
  beforeDrives: string;
  afterDrives: string;
  i: integer;
begin
  Result := FALSE;

  beforeDrives:= OTFEUnified.DrivesMounted();

  // Launch any user-specified pre-dismount program
  for i:=1 to length(beforeDrives) do
    begin
    if ((beforeDrives[i]<>#0) and (STU_INI_FILE.OptOTFPreDismountExe<>'')) then
      begin
      PrePostMountDismountExec('Pre-dismount', beforeDrives[i]+':'+STU_INI_FILE.OptOTFPreDismountExe, TRUE);
      end;
    end;

  dmntFailDrvs:= OTFEUnified.DismountAll(emergency);
  afterDrives:= OTFEUnified.DrivesMounted();

  if not(beforeDrives=afterDrives) then
    begin
    // Launch any user-specified post-dismount program
    PrePostMountDismountExec('Post-dismount', STU_INI_FILE.OptOTFPostDismountExe, FALSE);
    end;

  if dmntFailDrvs='' then
    begin
    Result := TRUE;
    end
  else
    begin
    if not(supressErrors) then
      begin
      if ReportDismountFailure(dmntFailDrvs) then
        begin
        Result := OTFCryptoDismountAll(TRUE, TRUE);
        end;
      end;
    end;

  RefreshDisplayAndTrayIcon();
  TVolumeInfo_F(volInfoDlg).SelectFirstMtdDrive();

end;

// Returns TRUE if the user wants to try an emergency dismount on the failed
// drives, otherwise FALSE
function TMain_F.ReportDismountFailure(failedDrvs: string): boolean;
var
  failedMsg: string;
  i: integer;
  msgDlgReply: WORD;
begin
  failedMsg := '';
  for i:=1 to length(failedDrvs) do
    begin
    if i>1 then
      begin
      failedMsg := failedMsg+', ';
      end;
    failedMsg := failedMsg + failedDrvs[i] + ':';
    end;

  msgDlgReply := MessageDlg('Failed to dismount drives: '+
                             failedMsg+
                             CRLF+
                             CRLF+
                             'If you have any files open on '+
                             failedMsg+
                             ', they should be closed before you attempt to dismount; click "No" and then close them.'+
                             CRLF+
                             CRLF+
                             'If you are sure that you have no files open on '+
                             failedMsg+
                             ', you may attempt an emergency dismount; click "Yes" below.'+
                             CRLF+
                             CRLF+
                             'WARNING: If you do have any such files open, this could result in data loss.'+
                             CRLF+
                             CRLF+
                             'Do you wish to attempt an emergency dismount on '+
                             failedMsg+
                             '?',
                            mtError,
                            [mbYes, mbNo],
                            0);

  Result := (msgDlgReply=mrYes);

end;

procedure TMain_F.ttCloseTimerTimer(Sender: TObject);
begin
  ttCloseTimer.enabled := FALSE;
  Close;

end;

procedure TMain_F.DisplayVolInfoDlg();
begin
  if not(IsAModalDialogDisplayed()) then
    begin
    // Force it to the front
    VolInfoDlg.Show();
    SetForeGroundWindow(VolInfoDlg.handle);
    end;

end;


procedure TMain_F.ShredFileDialogShow(Sender: TObject);
begin
  SendMessage(GetParent((Sender as TOpenDialog).handle),
              CDM_SETCONTROLTEXT,
              IDOK,
              integer(PChar('Shred')));

end;

procedure TMain_F.AddOrRemoveTrayIcon();
begin
  if STU_INI_FILE.OptUseTaskTrayIcon then
    begin
    Shell_NotifyIcon(NIM_ADD, @TrayIcon);
    end
  else
    begin
    Shell_NotifyIcon(NIM_DELETE, @TrayIcon);
    end;

end;

// Call this procedure to end the application cleanly
procedure TMain_F.ExitApp();
begin
  ttCloseTimer.enabled:=TRUE;

end;

procedure TMain_F.miTouchClick(Sender: TObject);
var
  touchDetailsDlg: TTouchFileSelect_F;
begin
  touchDetailsDlg:= TTouchFileSelect_F.create(nil);
  try
    touchDetailsDlg.ForceExistantFile := TRUE;
    if touchDetailsDlg.ShowModal()=mrOK then
      begin
      if touchDetailsDlg.DateTimeAsString='' then
        begin
        TouchFileOrDir(touchDetailsDlg.edFilename.text, Now());
        end
      else
        begin
        TouchFileOrDir(touchDetailsDlg.edFilename.text, StrToDateTime(touchDetailsDlg.DateTimeAsString));
        end;
      end;
  finally
    touchDetailsDlg.Free();
  end;

end;

procedure TMain_F.RefreshDisplayAndTrayIcon();
begin
  UpdateTrayIcon();

  // xxx - this will result in the display being refreshed twice, and can cause
  // it to flicker, but we don't always get the windows message when a drive is
  // added/removed
  if not(CommandLineOnly) then
    begin
    TVolumeInfo_F(VolInfoDlg).RefreshDisplay();
    end;

end;

procedure TMain_F.miHashClick(Sender: TObject);
var
  hashDlg: TCalculateFileHash_F;
  i: fhHashType;
begin
  if not(IsAModalDialogDisplayed()) then
    begin
    hashDlg := TCalculateFileHash_F.Create(nil);
    try
      ModalDialogBeingDisplayed(hashDlg);
      for i:=low(fhHashType) to high(fhHashType) do
        begin
        hashDlg.HashesEnabled[i]:= STU_INI_FILE.OptHashEnabled[i];
        end;
      hashDlg.Showmodal();
    finally
      ModalDialogNotBeingDisplayed();
      hashDlg.free;
    end;
    end; // not(IsAModalDialogDisplayed())

end;

procedure TMain_F.CommandLineHashFile();
var
  hashDlg: TCalculateFileHash_F;
  filename: string;
  i: fhHashType;
begin
  if SDUCommandLineParameter('hash', filename) then
    begin
    hashDlg := TCalculateFileHash_F.Create(nil);
    try
      for i:=low(fhHashType) to high(fhHashType) do
        begin
        hashDlg.HashesEnabled[i]:= STU_INI_FILE.OptHashEnabled[i];
        end;
      hashDlg.HashFile(SDUConvertSFNToLFN(filename));
      hashDlg.Showmodal();
    finally
      ModalDialogNotBeingDisplayed();
      hashDlg.free;
    end;
    end; // if SDUCommandLineParameter('hash', filename) then

end;

procedure TMain_F.SyncPopupMenuItemStates();
begin
  // Enabled...
  miAltSelfDestruct1.enabled        := miSelfDestruct1.enabled;
  miAltSelfDestructLine1.enabled    := miSelfDestructLine1.enabled;
  miAltMountVolume.enabled          := miMountVolume.enabled;
  miAltMountPartition.enabled       := miMountPartition.enabled;
  miAltLineMount.enabled            := miLineMount.enabled;
  miAltDismount.enabled             := miDismount.enabled;
  miAltLineDismount1.enabled        := miLineDismount1.enabled;
  miAltDismountAllNormal.enabled    := miDismountAllNormal.enabled;
  miAltDismountAllEmergency.enabled := miDismountAllEmergency.enabled;
  miAltLineDismount2.enabled        := miLineDismount2.enabled;
  miAltInformation.enabled          := miInformation.enabled;
  miAltLaunch.enabled               := miLaunch.enabled;
  miAltLaunchBestCrypt.enabled      := miLaunchBestCrypt.enabled;
  miAltLaunchCrossCrypt.enabled     := miLaunchCrossCrypt.enabled;
  miAltLaunchE4M.enabled            := miLaunchE4M.enabled;
  miAltLaunchFreeOTFE.enabled       := miLaunchFreeOTFE.enabled;
  miAltLaunchPGPDisk.enabled        := miLaunchPGPDisk.enabled;
  miAltLaunchScramDisk.enabled      := miLaunchScramDisk.enabled;
  miAltLaunchTrueCrypt.enabled      := miLaunchTrueCrypt.enabled;
  miAltShred.enabled                := miShred.enabled;
  miAltShredFile.enabled            := miShredFile.enabled;
  miAltShredDir.enabled             := miShredDir.enabled;
  miAltShredFreeSpace.enabled       := miShredFreeSpace.enabled;
  miAltOther.enabled                := miOther.enabled;
  miAltTouch.enabled                := miTouch.enabled;
  miAltHash.enabled                 := miHash.enabled;
  miAltOptions.enabled              := miOptions.enabled;
  miAltOptionsGeneral.enabled       := miOptionsGeneral.enabled;
  miAltOptionsOTFSystems.enabled    := miOptionsOTFSystems.enabled;
  miAltOptionsSelfDestruct.enabled  := miOptionsSelfDestruct.enabled;
  miAltLineOptions.enabled          := miLineOptions.enabled;
  miAltAbout.enabled                := miAbout.enabled;
  miAltExit.enabled                 := miExit.enabled;
  miAltSelfDestructLine2.enabled    := miSelfDestructLine2.enabled;
  miAltSelfDestruct2.enabled        := miSelfDestruct2.enabled;

  // Visible...
  miAltSelfDestruct1.visible        := miSelfDestruct1.visible;
  miAltSelfDestructLine1.visible    := miSelfDestructLine1.visible;
  miAltMountVolume.visible          := miMountVolume.visible;
  miAltMountPartition.visible       := miMountPartition.visible;
  miAltLineMount.visible            := miLineMount.visible;
  miAltDismount.visible             := miDismount.visible;
  miAltLineDismount1.visible        := miLineDismount1.visible;
  miAltDismountAllNormal.visible    := miDismountAllNormal.visible;
  miAltDismountAllEmergency.visible := miDismountAllEmergency.visible;
  miAltLineDismount2.visible        := miLineDismount2.visible;
  miAltInformation.visible          := miInformation.visible;
  miAltLaunch.visible               := miLaunch.visible;
  miAltLaunchBestCrypt.visible      := miLaunchBestCrypt.visible;
  miAltLaunchCrossCrypt.visible     := miLaunchCrossCrypt.visible;
  miAltLaunchE4M.visible            := miLaunchE4M.visible;
  miAltLaunchFreeOTFE.visible       := miLaunchFreeOTFE.visible;
  miAltLaunchPGPDisk.visible        := miLaunchPGPDisk.visible;
  miAltLaunchScramDisk.visible      := miLaunchScramDisk.visible;
  miAltLaunchTrueCrypt.visible      := miLaunchTrueCrypt.visible;
  miAltShred.visible                := miShred.visible;
  miAltShredFile.visible            := miShredFile.visible;
  miAltShredDir.visible             := miShredDir.visible;
  miAltShredFreeSpace.visible       := miShredFreeSpace.visible;
  miAltOther.visible                := miOther.visible;
  miAltTouch.visible                := miTouch.visible;
  miAltHash.visible                 := miHash.visible;
  miAltOptions.visible              := miOptions.visible;
  miAltOptionsGeneral.visible       := miOptionsGeneral.visible;
  miAltOptionsOTFSystems.visible    := miOptionsOTFSystems.visible;
  miAltOptionsSelfDestruct.visible  := miOptionsSelfDestruct.visible;
  miAltLineOptions.visible          := miLineOptions.visible;
  miAltAbout.visible                := miAbout.visible;
  miAltExit.visible                 := miExit.visible;
  miAltSelfDestructLine2.visible    := miSelfDestructLine2.visible;
  miAltSelfDestruct2.visible        := miSelfDestruct2.visible;

end;

procedure TMain_F.SetupShredderObj();
begin
  ShredderObj.FileDirUseInt           := STU_INI_FILE.OptShredFileDirUseInt;
  ShredderObj.FreeUseInt              := STU_INI_FILE.OptShredFreeUseInt;
  ShredderObj.ExtFileExe              := STU_INI_FILE.OptShredExtFileExe;
  ShredderObj.ExtDirExe               := STU_INI_FILE.OptShredExtDirExe;
  ShredderObj.ExtFreeSpaceExe         := STU_INI_FILE.OptShredExtFreeSpaceExe;
  ShredderObj.ExtShredFilesThenDir    := STU_INI_FILE.OptShredExtShredFilesThenDir;
  ShredderObj.IntFirstBytes           := STU_INI_FILE.OptShredIntFirstBytes;
  ShredderObj.IntPasses               := STU_INI_FILE.OptShredIntPasses ;
  ShredderObj.IntGutmann              := STU_INI_FILE.OptShredIntGutmann;
  ShredderObj.IntFreeSpcFileSize      := STU_INI_FILE.OptShredIntFreeSpcFileSize;
  ShredderObj.IntFreeSpcFileCreationBlkSize := STU_INI_FILE.OptShredIntFreeSpcFileCreationBlkSize;
  ShredderObj.IntFileBufferSize       := STU_INI_FILE.OptShredIntFileBufferSize;

end;


// Set "datrandomDatee" to a random date between startDT and endDT
procedure TMain_F.GetRandomDate(var randomDate: SYSTEMTIME; startDT: TDateTime; endDT: TDateTime);
var
  startTimeStamp: TTimeStamp;
  endTimeStamp: TTimeStamp;
  randomTimeStamp: TTimeStamp;
  randomDateTime: TDateTime;
begin
  startTimeStamp := DateTimeToTimeStamp(startDT);
  endTimeStamp := DateTimeToTimeStamp(endDT);

  randomize;

  // xxx - THIS CAN POTENTIALLY RETURN DATES SLIGHTLY PRIOR TO startDT AND
  //       AFTER endDT
  randomTimeStamp.Date := (random(endTimeStamp.date-startTimeStamp.date)+startTimeStamp.date);
  randomTimeStamp.Time := (random(endTimeStamp.time-startTimeStamp.time)+startTimeStamp.time);

  randomDateTime := TimeStampToDateTime(randomTimeStamp);

  DecodeDate(randomDateTime, randomDate.wYear, randomDate.wMonth, randomDate.wDay);
  DecodeTime(randomDateTime, randomDate.wHour, randomDate.wMinute, randomDate.wSecond, randomDate.wMilliseconds);

end;


// waitForExit - set to TRUE if you want to block until the executable finishes
procedure TMain_F.PrePostMountDismountExec(msgPart: string; exeFilename: string; waitForExit: boolean);
begin
  if (exeFilename<>'') then
    begin
    if (not(FileExists(exeFilename)) and (STU_INI_FILE.OptOTFPrePostWarnNotFound)) then
      begin
      MessageDlg('Post-mount executable "'+exeFilename+'" not found', mtWarning, [mbOK], 0);
      end
    else
      begin
      // exeFilename can't have spaces, so convert to SFN
      exeFilename := SDUConvertLFNToSFN(exeFilename);
      if waitForExit then
        begin
        SDUWinExecAndWait32(exeFilename, SW_SHOWDEFAULT);
        end
      else
        begin
        winexec(PChar(exeFilename), SW_SHOWDEFAULT);
        end;
      end;
    end;

end;


procedure TMain_F.miLaunchTrueCryptClick(Sender: TObject);
var
  appExe: string;
begin
  appExe := OTFEUnified.OTFComponents[otfesTrueCrypt].GetMainExe();
  if (WinExec(PChar(appExe), SW_RESTORE))<31 then
    begin
    ErrorMessage('Error running TrueCrypt; application not found at "'+appExe+'"');
    end;

end;


procedure TMain_F.miLaunchFreeOTFEClick(Sender: TObject);
begin
  if (WinExec(PChar(STU_INI_FILE.OptOTFFreeOTFEExe), SW_RESTORE))<31 then
    begin
    ErrorMessage('Error running FreeOTFE; please ensure correct filename and path have been entered in the Options dialog');
    end;

end;

procedure TMain_F.miLaunchCrossCryptClick(Sender: TObject);
begin
  if (WinExec(PChar(STU_INI_FILE.OptOTFCrossCryptExe), SW_RESTORE))<31 then
    begin
    ErrorMessage('Error running CrossCrypt; please ensure correct filename and path have been entered in the Options dialog');
    end;

end;


// -----------------------------------------------------------------------------

// -----------------------------------------------------------------------------
// -----------------------------------------------------------------------------
{$WARN SYMBOL_PLATFORM ON}
{$WARN UNIT_PLATFORM ON}
// -----------------------------------------------------------------------------

END.

