unit OTFVolumeDetailsCrossCrypt_U;
// Description:
// By Sarah Dean
// Email: sdean12@softhome.net
// WWW:   http://www.SDean12.org/
//
// -----------------------------------------------------------------------------
//


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls,
  OTFVolumeDetails_U;

type
  TOTFVolumeDetailsCrossCrypt_F = class(TOTFVolumeDetails_F)
    gbVolInfo: TGroupBox;
    Label2015: TLabel;
    Label2022: TLabel;
    Label2023: TLabel;
    edFilename: TEdit;
    edDriveMountedAs: TEdit;
    edReadOnly: TEdit;
    edUserDevice: TEdit;
    edKernelDevice: TEdit;
    Label2020: TLabel;
    Label9000: TLabel;
    edVolLabel: TEdit;
    Label9101: TLabel;
    Label9100: TLabel;
  private
    { Private declarations }
  public
    constructor Create(AOwner: TComponent); override;
    function  DisplayInfoForDrive(driveLetter: char): boolean; override;
  end;

implementation

{$R *.DFM}

uses
  OTFECrossCrypt_U,
  OTFEUnified_U,
  SDUGeneral;

constructor TOTFVolumeDetailsCrossCrypt_F.Create(AOwner: TComponent);
begin
  inherited;

  OTFSystem:= otfesCrossCrypt;

end;

function TOTFVolumeDetailsCrossCrypt_F.DisplayInfoForDrive(driveLetter: char): boolean;
var
  info: TOTFECrossCryptVolumeInfo;
begin
  edDriveMountedAs.text := driveLetter+':';
  edVolLabel.text       := SDUVolumeID(driveLetter);
  edFilename.text       := '<Unknown>';
  edReadOnly.text       := '<Unknown>';
  edKernelDevice.text   := '<Unknown>';
  edUserDevice.text     := '<Unknown>';


  if TOTFECrossCrypt(OTFComponent).GetVolumeInfo(driveLetter, info) then
    begin
    edFilename.text       := info.Filename;
    edKernelDevice.text   := info.KernelModeDeviceName;
    edUserDevice.text     := info.UserModeDeviceName;

    if info.readonly then
      begin
      edReadOnly.text := 'Readonly';
      end
    else
      begin
      edReadOnly.text := 'Read/Write';
      end;

    end;

  Result := TRUE;
  
end;

END.

