unit OTFVolumeDetailsE4M_U;
// Description:
// By Sarah Dean
// Email: sdean12@softhome.net
// WWW:   http://www.SDean12.org/
//
// -----------------------------------------------------------------------------
//


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls,
  OTFVolumeDetails_U;

type
  TOTFVolumeDetailsE4M_F = class(TOTFVolumeDetails_F)
    gbVolInfo: TGroupBox;
    Label2015: TLabel;
    Label2022: TLabel;
    Label2023: TLabel;
    Label2008: TLabel;
    Label2011: TLabel;
    Label2001: TLabel;
    edFilename: TEdit;
    edDriveMountedAs: TEdit;
    edReadOnly: TEdit;
    edAlgorithm: TEdit;
    edKeyGen: TEdit;
    edVolumeType: TEdit;
    Label2020: TLabel;
    Label9000: TLabel;
    edVolLabel: TEdit;
  private
    { Private declarations }
  public
    constructor Create(AOwner: TComponent); override;
    function  DisplayInfoForDrive(driveLetter: char): boolean; override;
  end;

implementation

{$R *.DFM}

uses
  OTFEE4M_U,
  OTFEE4MStructures_U,
  OTFEUnified_U,
  SDUGeneral;

constructor TOTFVolumeDetailsE4M_F.Create(AOwner: TComponent);
begin
  inherited;

  OTFSystem:= otfesE4M;

end;

function TOTFVolumeDetailsE4M_F.DisplayInfoForDrive(driveLetter: char): boolean;
var
  info: TOTFEE4MVolumeInfo;
begin
  info := TOTFEE4M(OTFComponent).GetDriveInfo(driveLetter);
  edFilename.text := info.volumeFilename;
  edDriveMountedAs.text := info.mountedAs+':';
  edVolLabel.text := SDUVolumeID(driveLetter);
  edAlgorithm.text := info.cipherName;
  edKeyGen.text := info.hashName;
  edVolumeType.text := info.volumeTypeName;

  if info.readonly then
    begin
    edReadOnly.text := 'Readonly';
    end
  else
    begin
    edReadOnly.text := 'Read/Write';
    end;

  Result := TRUE;
  
end;

END.

