unit OTFVolumeDetailsPGPDisk_U;
// Description:
// By Sarah Dean
// Email: sdean12@softhome.net
// WWW:   http://www.SDean12.org/
//
// -----------------------------------------------------------------------------
//


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls,
  OTFVolumeDetails_U;

type
  TOTFVolumeDetailsPGPDisk_F = class(TOTFVolumeDetails_F)
    GroupBox1: TGroupBox;
    Label3001: TLabel;
    edFilename: TEdit;
    Label2023: TLabel;
    edVolLabel: TEdit;
    Label9000: TLabel;
    edDriveMountedAs: TEdit;
    Label2022: TLabel;
    Label2024: TLabel;
    edReadOnly: TEdit;
  private
    { Private declarations }
  public
    constructor Create(AOwner: TComponent); override;
    function  DisplayInfoForDrive(driveLetter: char): boolean; override;
  end;

implementation

{$R *.DFM}

uses
  OTFEPGPDisk_U,
  OTFEPGPDiskStructures_U,
  OTFEUnified_U,
  SDUGeneral;

constructor TOTFVolumeDetailsPGPDisk_F.Create(AOwner: TComponent);
begin
  inherited;

  OTFSystem:= otfesPGPDisk;

end;

function TOTFVolumeDetailsPGPDisk_F.DisplayInfoForDrive(driveLetter: char): boolean;
begin
  edDriveMountedAs.text := driveLetter+':';
  edVolLabel.text := SDUVolumeID(driveLetter);
  edFilename.text := TOTFEPGPDisk(OTFComponent).GetVolFileForDrive(driveLetter);

  if TOTFEPGPDisk(OTFComponent).IsDriveReadonly(driveLetter) then
    begin
    edReadOnly.text := 'Readonly';
    end
  else
    begin
    edReadOnly.text := 'Read/Write';
    end;

  Result := TRUE;

end;

END.

